/*****************************************************************/
/*                                                               */
/*   CASIO fx-9860G SDK Library                                  */
/*                                                               */
/*   File name : [ProjectName].c                                 */
/*                                                               */
/*   Copyright (c) 2006 CASIO COMPUTER CO., LTD.                 */
/*                                                               */
/*****************************************************************/
#include "fxlib.h"
#include "math.h"
#include "stdlib.h"
#include "string.h"
#include "stdio.h"
#include "MonochromeLib.h"
#include "memory.h"
#include "usefull.h"
#include "TouchLib.h"
#include "LibText.h"

//****************************************************************************
//  AddIn_main (Sample program main function)
//
//  param   :   isAppli   : 1 = This application is launched by MAIN MENU.
//                        : 0 = This application is launched by a strip in eACT application.
//
//              OptionNum : Strip number (0~3)
//                         (This parameter is only used when isAppli parameter is 0.)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************

static int SysCallCode[] = {0xD201422B,0x60F20000,0x80010070};				//Truc pour pouvoir utiliser le syscall du temps
static int (*SysCall)(int R4, int R5, int R6, int R7, int FNo ) = (void*)&SysCallCode;

int RTC_getTicks(void)		//Fonction pour pouvoir utiliser le temps en tics 1/128
{
     return (*SysCall)(0, 0, 0, 0, 0x3B); // on dclare la fonction voulue selon son numro (ici 0x3B)
}

#define ABS(x) ((x>0)? x:-x)

#define FILEPATH "\\\\fls0\\2048dlx.sav"

void Read(int *Record, int *Score, int *TempsPartie, unsigned char Grille[4][4], unsigned char *MedaillesObtenues, unsigned char *Statistiques){		//Truc qui sers pour la lecture de fichiers
	int i;
	int handle;
	handle = memory_openfile(FILEPATH,_OPENMODE_READ);
	memory_readfile(handle,(void *)Record,4,-1);
	memory_readfile(handle,(void *)Score,4,-1);
	memory_readfile(handle,(void *)TempsPartie,4,-1);
	for(i=0;i<4;i++)memory_readfile(handle,(void *)(Grille+i),4,-1);
	memory_readfile(handle,(void *)MedaillesObtenues,30,-1);
	memory_readfile(handle,(void *)Statistiques,68,-1);
	memory_closefile(handle);
	}

void Save(int Record, int Score, int TempsPartie, unsigned char **Grille, unsigned char *MedaillesObtenues, unsigned char *Statistiques){		//Truc qui sers pour la sauvegarde de fichiers
	int i;
	int handle;
	memory_deletefile(FILEPATH);
	memory_createfile(FILEPATH,126);
	handle = memory_openfile(FILEPATH,_OPENMODE_WRITE);
	memory_writefile(handle,(void *)(&Record),4);
	memory_writefile(handle,(void *)(&Score),4);
	memory_writefile(handle,(void *)(&TempsPartie),4);
	memory_writefile(handle,(void *)Grille,16);
	memory_writefile(handle,(void *)MedaillesObtenues,30);
	memory_writefile(handle,(void *)Statistiques,68);
	memory_closefile(handle);
	}

int AddIn_main(int isAppli,unsigned short OptionNum)		//Fonction du code du jeu entier
{
int Score=0;
int Record=0;
int AffTxt;
int ChoixMode;
int Direction;
int X;
int Y;
int X2;
int Y2;
int I; 
int J;
int NbrDeplacement;
int M;
int E;
int Case1;
int Case2;
int TestCoups;
int Z;
int Z2;
int TestCase;
int Apparition;
int Gagne;
int ChoixAnimation=1;
int i;
int j;
int Chance;
unsigned char TestFusion1[]={0,0,0,0,0,0,0,0};
unsigned char TestFusion2[]={0,0,0,0,0,0,0,0};
int NbrFusion;
int NbrCombo;
int NbrSuite;
int TestSuite;
int NbrDesordonne;
int TestArtistique;
int TestDernierSucce;
int Secondes;
int Minutes;
int Heures;
int TempsPartie;
int TempsSession;
int TempsReference;
int TempsActuel;
int ChoixSucceOrganisation;
int Defilement;
int Ralentissement;
char buffer[16];

TL_Point point1 = {-1, -1};
TL_Point point2 = {-1, -1};
TL_Point point3 = {-1, -1};

unsigned char Grille[4][4]={{0,0,0,0},{0,0,0,0},{0,0,0,0},{0,0,0,0}};
unsigned char Boleens1[]={0,0,0,0};
unsigned char Boleens2[]={0,0,0,0};
unsigned int Statistiques[]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

unsigned char MedaillesObtenues[]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};

const unsigned char P2[15][32]={
	{0x0,0x0,0x0,0x0,0x3f,0xfc,0x3f,0xfc,0x3f,0xfc,0x3f,0xfc,0x3f,0xfc,0x3f,0xfc,0x3f,0xfc,0x3f,0xfc,0x3f,0xfc,0x3f,0xfc,0x3f,0xfc,0x3f,0xfc,0x0,0x0,0x0,0x0},
	{0x0,0x0,0x7f,0xfe,0x7f,0xfe,0x7f,0xfe,0x7f,0xfe,0x7f,0xfe,0x7f,0xfe,0x7f,0xfe,0x7f,0xfe,0x7f,0xfe,0x7f,0xfe,0x7f,0xfe,0x7f,0xfe,0x7f,0xfe,0x7f,0xfe,0x0,0x0},
	{0x0,0x0,0x7f,0xfe,0x7f,0xfe,0x7c,0x3e,0x78,0x1e,0x79,0x9e,0x7f,0x9e,0x7f,0x1e,0x7e,0x3e,0x7c,0x7e,0x78,0xfe,0x78,0x1e,0x78,0x1e,0x7f,0xfe,0x7f,0xfe,0x0,0x0},
	{0x0,0x0,0x7f,0xfe,0x7f,0xfe,0x7e,0x1e,0x7e,0x1e,0x7c,0x9e,0x7c,0x9e,0x79,0x9e,0x79,0x9e,0x78,0x1e,0x78,0x1e,0x7f,0x9e,0x7f,0x9e,0x7f,0xfe,0x7f,0xfe,0x0,0x0},
	{0x0,0x0,0x7f,0xfe,0x7f,0xfe,0x7c,0x3e,0x78,0x1e,0x79,0x9e,0x79,0x9e,0x7c,0x3e,0x78,0x1e,0x79,0x9e,0x79,0x9e,0x78,0x1e,0x7c,0x3e,0x7f,0xfe,0x7f,0xfe,0x0,0x0},
	{0x0,0x0,0x7f,0xfe,0x7f,0xfe,0x73,0xe,0x62,0x6,0x62,0x66,0x72,0x7e,0x72,0xe,0x72,0x6,0x72,0x66,0x72,0x66,0x72,0x6,0x73,0xe,0x7f,0xfe,0x7f,0xfe,0x0,0x0},
	{0x0,0x0,0x7f,0xfe,0x7f,0xfe,0x7f,0xfe,0x63,0xc6,0x41,0x82,0x59,0xb2,0x73,0xf2,0x79,0xe6,0x59,0xce,0x41,0x9a,0x63,0x82,0x7f,0xfe,0x7f,0xfe,0x7f,0xfe,0x0,0x0},
	{0x0,0x0,0x7f,0xfe,0x7f,0xfe,0x7f,0xfe,0x61,0xf2,0x4c,0xe2,0x4f,0xc2,0x49,0x92,0x40,0xb2,0x4c,0x82,0x4c,0xf2,0x61,0xf2,0x7f,0xfe,0x7f,0xfe,0x7f,0xfe,0x0,0x0},
	{0x0,0x0,0x7f,0xfe,0x5f,0xfa,0x7f,0xfe,0x7f,0xfe,0x6c,0xe6,0x4b,0x5a,0x6f,0x5a,0x6e,0xe6,0x6d,0xda,0x6b,0xda,0x68,0x66,0x7f,0xfe,0x5f,0xfa,0x7f,0xfe,0x0,0x0},
	{0x0,0x0,0x7f,0xfe,0x4f,0xf2,0x5f,0xfa,0x7f,0xfe,0x6c,0x66,0x55,0xde,0x74,0xc6,0x6f,0x5a,0x5f,0x5a,0x44,0xe6,0x7f,0xfe,0x5f,0xfa,0x4f,0xf2,0x7f,0xfe,0x0,0x0},
	{0x0,0x0,0x7f,0xfe,0x4d,0xb2,0x5f,0xfa,0x7f,0xfe,0x43,0x66,0x5e,0x5a,0x47,0x7a,0x7b,0x76,0x7b,0x6e,0x47,0x42,0x7f,0xfe,0x5f,0xfa,0x4d,0xb2,0x7f,0xfe,0x0,0x0},
	{0x0,0x0,0x7f,0xfe,0x50,0x2,0x5e,0x2,0x5b,0x2,0x55,0xe2,0x75,0x32,0x55,0xd2,0x5b,0xbe,0x4f,0x7a,0x41,0x12,0x41,0xea,0x40,0x22,0x40,0x3a,0x7f,0xfe,0x0,0x0},
	{0x0,0x0,0x7f,0xfe,0x78,0x2,0x4c,0x7a,0x77,0xa,0x6d,0x82,0x5a,0xf2,0x42,0xd2,0x7a,0x9e,0x4d,0x42,0x47,0xa,0x51,0xc2,0x5c,0x6a,0x40,0x22,0x7f,0xfe,0x0,0x0},
	{0x0,0x0,0x7f,0xfe,0x74,0x2,0x64,0xfa,0x57,0x7a,0x45,0x9a,0x72,0xea,0x5a,0xb2,0x4a,0x5e,0x4d,0x92,0x57,0xce,0x59,0x26,0x5d,0xea,0x40,0x36,0x7f,0xfe,0x0,0x0},
	{0x0,0x0,0x7f,0xfe,0x47,0xaa,0x57,0xd6,0x45,0xea,0x55,0xf6,0x45,0xba,0x7d,0x5e,0x7d,0x9e,0x5f,0xc6,0x6f,0x3a,0x57,0xf6,0x6b,0xee,0x55,0xe2,0x7f,0xfe,0x0,0x0}};

const unsigned char Chiffres[10][7]={
	{0x7c,0x44,0x54,0x54,0x54,0x44,0x7c},
	{0x78,0x48,0x68,0x28,0x6c,0x44,0x7c},
	{0x7c,0x44,0x74,0x44,0x5c,0x44,0x7c},
	{0x7c,0x44,0x74,0x24,0x74,0x44,0x7c},
	{0x7c,0x54,0x54,0x44,0x74,0x14,0x1c},
	{0x7c,0x44,0x5c,0x44,0x74,0x44,0x7c},
	{0x7c,0x44,0x5c,0x44,0x54,0x44,0x7c},
	{0x7c,0x44,0x74,0x24,0x34,0x14,0x1c},
	{0x7c,0x44,0x54,0x44,0x54,0x44,0x7c},
	{0x7c,0x44,0x54,0x44,0x74,0x44,0x7c}};

const unsigned char Im0[]={0x0,0x0,0x7f,0xfe,0x7f,0xfe,0x7c,0x3e,0x78,0x1e,0x79,0x9e,0x79,0x9e,0x79,0x9e,0x79,0x9e,0x79,0x9e,0x79,0x9e,0x78,0x1e,0x7c,0x3e,0x7f,0xfe,0x7f,0xfe,0x0,0x0};
const unsigned char DELUX[]={0x55,0xff,0xff,0xff,0xff,0xff,0xf5,0x40,0xab,0x80,0x0,0x0,0x0,0x0,0x3a,0xa0,0x55,0x9e,0x1f,0x10,0x11,0x11,0x35,0x40,0xab,0x91,0x10,0x10,0x11,0xa,0x3a,0xa0,0x55,0x91,0x1c,0x10,0x11,0x4,0x35,0x40,0xab,0x91,0x10,0x10,0x11,0xa,0x3a,0xa0,0x55,0x9e,0x1f,0x1f,0xe,0x11,0x35,0x40,0xab,0x80,0x0,0x0,0x0,0x0,0x3a,0xa0,0x55,0xff,0xff,0xff,0xff,0xff,0xf5,0x40,0xab,0xff,0xff,0xff,0xff,0xff,0xfa,0xa0,0x55,0x55,0x55,0x55,0x55,0x55,0x55,0x40,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xaa,0xa0};
const unsigned char Kirafi[]={0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xe0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xe0,0x86,0xe,0xe,0xe,0xe,0xe,0xc,0x20,0x8d,0xb5,0xf4,0xe4,0xe5,0xf5,0xf6,0x20,0x9d,0x55,0x15,0x15,0x15,0x15,0x17,0x20,0xbd,0x55,0xb5,0x55,0x55,0x75,0xb7,0xa0,0xa5,0x24,0xa5,0x25,0x15,0x24,0xa4,0xa0,0xbd,0x55,0xb5,0x55,0x55,0x65,0xb7,0xa0,0x9d,0x55,0x15,0x55,0x55,0x45,0x17,0x20,0x8d,0xb5,0xf5,0xb5,0xb5,0xc5,0xf6,0x20,0x86,0xe,0xe,0xe,0xe,0xe,0xc,0x20,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xe0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xe0};

const unsigned char ImScore1[]={0xcc,0xc0,0xf3,0xce,0x38,0xf0,0x66,0x60,0x66,0x61,0x14,0x51,0x45,0x10,0xcc,0xc0,0x33,0x31,0x65,0xd5,0x55,0x71,0x99,0x80,0x19,0x99,0x15,0x15,0x49,0x23,0x33,0x0,0x33,0x30,0xd5,0xd5,0x55,0x71,0x99,0x80,0x66,0x61,0x14,0x51,0x55,0x10,0xcc,0xc0,0xcc,0xc1,0xe3,0xce,0x6c,0xf0,0x66,0x60};
const unsigned char ImScore2[]={0xee,0xe0,0xf3,0xce,0x38,0xf0,0xee,0xe0,0x77,0x71,0x14,0x51,0x45,0x11,0xdd,0xc0,0x3b,0xb9,0x65,0xd5,0x55,0x73,0xbb,0x80,0x1d,0xdd,0x15,0x15,0x49,0x27,0x77,0x0,0x3b,0xb8,0xd5,0xd5,0x55,0x73,0xbb,0x80,0x77,0x71,0x14,0x51,0x55,0x11,0xdd,0xc0,0xee,0xe1,0xe3,0xce,0x6c,0xf0,0xee,0xe0};
const unsigned char ImRecord[]={0x0,0x3,0x8f,0x3c,0xe3,0x9c,0x0,0x0,0xff,0xf4,0x51,0x45,0x14,0x52,0x7f,0xf8,0xc9,0x35,0x57,0x5d,0x55,0x55,0x64,0x98,0xb6,0xd4,0x92,0x51,0x54,0x95,0x5b,0x68,0xc9,0x35,0x57,0x5d,0x55,0x55,0x64,0x98,0xff,0xf5,0x51,0x45,0x15,0x52,0x7f,0xf8,0x0,0x6,0xcf,0x3c,0xe6,0xdc,0x0,0x0};
const unsigned char ImPerdu[]={0x10,0x10,0x71,0xe7,0x38,0xd8,0x40,0x40,0x54,0x54,0x8a,0x28,0xa4,0xa9,0x51,0x50,0x38,0x38,0xaa,0xea,0xaa,0xa8,0xe0,0xe0,0xfe,0xfe,0x8a,0x49,0x2a,0xab,0xfb,0xf8,0x38,0x38,0xb2,0xea,0xaa,0xa8,0xe0,0xe0,0x54,0x54,0xa2,0x2a,0xa4,0x89,0x51,0x50,0x10,0x10,0xe1,0xed,0xb8,0x70,0x40,0x40};
const unsigned char ImGagne[]={0x0,0x1,0xe3,0x8f,0x33,0x9e,0x0,0x0,0x0,0x3,0x24,0x59,0x2a,0xa2,0x0,0x0,0xf0,0x2,0xf5,0x57,0xa6,0xac,0x0,0x78,0x98,0x2,0x94,0x54,0xaa,0xa4,0x0,0xc8,0xee,0x2,0xd5,0x56,0xac,0xae,0x3,0xb8,0xdb,0x3,0x35,0x59,0xaa,0xa2,0x6,0xd8,0xb5,0xe1,0xe6,0xcf,0x39,0x9e,0x3d,0x68,0x85,0xa0,0x0,0x0,0x0,0x0,0x2d,0x8,0xf5,0x3c,0x0,0x0,0x0,0x1,0xe5,0x78,0x1a,0x84,0x1,0xed,0x9e,0x1,0xa,0xc0,0xe,0x14,0x2,0x2a,0xa2,0x1,0x43,0x80,0x3,0x84,0x2,0xea,0xae,0x1,0xe,0x0,0x0,0xd4,0x2,0x45,0x24,0x1,0x58,0x0,0x0,0x44,0x2,0xea,0xae,0x1,0x10,0x0,0x0,0x7c,0x2,0x2a,0xa2,0x1,0xf0,0x0,0x0,0x0,0x1,0xed,0x9e,0x0,0x0,0x0};
const unsigned char ImExe[]={0x7b,0x67,0x80,0x8a,0xa8,0x80,0xba,0xab,0x80,0x91,0x49,0x0,0xba,0xab,0x80,0x8a,0xa8,0x80,0x7b,0x67,0x80};
const unsigned char ImTime[]={0xfb,0xee,0xe7,0x80,0x8a,0x2b,0xa8,0x80,0xdb,0x69,0x2b,0x80,0x51,0x4a,0xa9,0x0,0x53,0x6b,0xab,0x80,0x52,0x2a,0xa8,0x80,0x73,0xee,0xe7,0x80};
const unsigned char ImTempsNul[]={0xfb,0xe0,0x3e,0xf8,0xf,0xbe,0x8a,0x20,0x22,0x88,0x8,0xa2,0xaa,0xa2,0x2a,0xa8,0x8a,0xaa,0xaa,0xa0,0x2a,0xa8,0xa,0xaa,0xaa,0xa2,0x2a,0xa8,0x8a,0xaa,0x8a,0x20,0x22,0x88,0x8,0xa2,0xfb,0xe0,0x3e,0xf8,0xf,0xbe};


const unsigned char TexteMenu[12][56]={
	{0x4,0x5d,0x55,0xdd,0x40,0x6,0x55,0x55,0x15,0x40,0x5,0x55,0x55,0x9d,0x40,0x4,0xd5,0x55,0x15,0x40,0x4,0x5d,0xc9,0xd5,0xc0},
	{0x1,0x9c,0xe6,0xdb,0x3c,0xe6,0xc0,0x0,0x1,0x55,0x15,0x55,0x45,0x15,0x40,0x0,0x1,0x35,0x55,0x55,0x5d,0x55,0x40,0x0,0x1,0x55,0x55,0x55,0x49,0x15,0x40,0x0,0x1,0x65,0x55,0x55,0x5d,0x55,0x40,0x0,0x1,0x55,0x14,0x4a,0x45,0x54,0x40,0x0,0x1,0xcc,0xe3,0x84,0x3d,0xb3,0x80,0x0},
	{0xee,0x8b,0xba,0x2a,0xee,0x8a,0xc9,0x13,0x2a,0x8a,0x8a,0xa9,0x12,0xaa,0xcc,0x8a,0x99,0x12,0x6a,0x8a,0xee,0x89,0x3a,0x2e,0xea},
	{0x79,0xcc,0xef,0xbe,0xce,0xd9,0xe7,0x0,0x8a,0x2a,0xa8,0xa2,0xaa,0xaa,0x28,0x80,0xba,0xa9,0xad,0xb6,0x9a,0xaa,0xea,0x80,0xa2,0xaa,0xa5,0x14,0xaa,0xaa,0x49,0x0,0xba,0xab,0x25,0x36,0xb2,0xaa,0xea,0x80,0x8a,0x2a,0xa5,0x22,0xaa,0x8a,0x2a,0x80,0x79,0xce,0x67,0x3e,0xe6,0x71,0xed,0x80},
	{0x0,0xea,0xee,0xee,0x0,0x0,0x8a,0x88,0x88,0x0,0x0,0xea,0x88,0xce,0x0,0x0,0x2a,0x88,0x82,0x0,0x0,0xee,0xee,0xee,0x0},
	{0x0,0xf,0x6c,0xf3,0xcf,0x3c,0x0,0x0,0x0,0x11,0x55,0x14,0x51,0x44,0x0,0x0,0x0,0x16,0x55,0x75,0xd7,0x58,0x0,0x0,0x0,0x11,0x55,0x45,0x12,0x44,0x0,0x0,0x0,0xd,0x55,0x75,0xd7,0x34,0x0,0x0,0x0,0x11,0x45,0x14,0x51,0x44,0x0,0x0,0x0,0x1e,0x38,0xf3,0xcf,0x78,0x0,0x0},
	{0x0,0x3b,0xbb,0xb8,0x0,0x0,0x21,0x29,0x20,0x0,0x0,0x39,0x39,0x38,0x0,0x0,0x9,0x29,0x8,0x0,0x0,0x39,0x29,0x38,0x0},
	{0x0,0x1,0xef,0x9c,0xf9,0xe0,0x0,0x0,0x0,0x2,0x28,0xa2,0x8a,0x20,0x0,0x0,0x0,0x2,0xcd,0xaa,0xda,0xc0,0x0,0x0,0x0,0x2,0x25,0x22,0x52,0x20,0x0,0x0,0x0,0x1,0xa5,0x2a,0x51,0xa0,0x0,0x0,0x0,0x2,0x25,0x2a,0x52,0x20,0x0,0x0,0x0,0x3,0xc7,0x36,0x73,0xc0,0x0,0x0},
	{0x3,0xbb,0xb3,0xbb,0x80,0x2,0x2a,0x29,0x12,0x0,0x2,0x33,0x29,0x13,0x80,0x2,0x2a,0x29,0x10,0x80,0x3,0xab,0xb3,0x93,0x80},
	{0x0,0x79,0xc7,0xb8,0xfb,0xe7,0x80,0x0,0x0,0x8a,0x28,0xa4,0x8a,0x28,0x80,0x0,0x0,0xba,0xab,0xaa,0xdb,0x6b,0x0,0x0,0x0,0xa2,0x49,0x2a,0x51,0x48,0x80,0x0,0x0,0xba,0xab,0xaa,0xd9,0x46,0x80,0x0,0x0,0x8a,0xa8,0xa4,0x89,0x48,0x80,0x0,0x0,0x7b,0x67,0xb8,0xf9,0xcf,0x0,0x0},
	{0x3,0x95,0xdd,0xdd,0xc0,0x4,0x54,0x88,0x91,0x40,0x5,0x54,0x88,0x99,0x80,0x4,0x94,0x88,0x91,0x40,0x3,0x5d,0xc8,0x9d,0x40},
	{0x0,0x71,0xb7,0xdf,0x7c,0xf3,0x80,0x0,0x0,0x89,0x54,0x51,0x45,0x14,0x40,0x0,0x1,0x75,0x56,0xdb,0x6d,0x75,0x40,0x0,0x1,0x55,0x52,0x8a,0x29,0x24,0x80,0x0,0x1,0x69,0x56,0xca,0x29,0x75,0x40,0x0,0x0,0x95,0x14,0x4a,0x29,0x15,0x40,0x0,0x0,0x6c,0xe7,0xce,0x38,0xf6,0xc0,0x0}};

const unsigned char BandeauSucces[]={0x82,0x8,0x20,0x82,0x8,0x20,0x82,0x0,0x2,0x8,0x20,0x82,0x8,0x20,0x82,0x8,0x82,0x8,0x20,0x82,0x8,0x20,0x82,0x0,0x2,0x8,0x20,0x82,0x8,0x20,0x82,0x8,0x92,0xe9,0xaa,0x9a,0x6b,0x2e,0x92,0x0,0x2,0xe9,0xaa,0x9a,0x6b,0x2e,0x92,0x48,0xaa,0x8a,0x2a,0xa2,0x8a,0xa8,0xaa,0x0,0x2,0x8a,0x2a,0xa2,0x8a,0xa8,0xaa,0xa8,0xba,0xc9,0x2c,0xa2,0x4a,0xac,0xba,0x0,0x2,0xc9,0x2c,0xa2,0x4a,0xac,0xba,0xe8,0xaa,0x88,0xaa,0xa2,0x2a,0xa8,0xaa,0x0,0x2,0x88,0xaa,0xa2,0x2a,0xa8,0xaa,0xa8,0xaa,0x8b,0x2a,0x9a,0xcb,0x2e,0xaa,0x0,0x2,0x8b,0x2a,0x9a,0xcb,0x2e,0xaa,0xa8,0xc3,0xc,0x30,0xc3,0xc,0x30,0xc2,0x0,0x2,0x18,0x61,0x86,0x18,0x61,0x86,0x18,0x63,0x8e,0x38,0xe3,0x8e,0x38,0xe2,0x0,0x2,0x38,0xe3,0x8e,0x38,0xe3,0x8e,0x30,0x3e,0xfb,0xef,0xbe,0xfb,0xef,0xbe,0x0,0x3,0xef,0xbe,0xfb,0xef,0xbe,0xfb,0xe0};
const unsigned char SelectSucce[]={0x80,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8,0x80,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8,0x80,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8,0x80,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8,0x80,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8,0x80,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x8,0xc0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x18,0xc0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x18,0xe0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x38,0x7f,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xf0};

const unsigned char ImTexteSucces[10][56]={
	{0x3,0xff,0xff,0xff,0xff,0xff,0xf7,0x0,0x6,0x30,0xc3,0x18,0x41,0x18,0xdd,0x0,0x5,0xd7,0x5d,0xb7,0xf7,0xb7,0x4d,0x0,0x4,0x15,0x55,0xb4,0x14,0xb5,0x55,0x0,0x5,0xd7,0x5d,0xb7,0xd5,0xb7,0x59,0x0,0x5,0x50,0xc3,0x18,0x55,0x18,0xdd,0x0,0x7,0x7f,0xff,0xff,0xdd,0xff,0xf7,0x0},
	{0x0,0x7,0xfd,0xff,0xff,0xf7,0x0,0x0,0x0,0x4,0x15,0x61,0x18,0xdd,0x0,0x0,0x0,0x5,0xf5,0x5f,0xb7,0x4d,0x0,0x0,0x0,0x4,0x55,0x63,0xb5,0x55,0x0,0x0,0x0,0x5,0xd7,0x7d,0xb7,0x59,0x0,0x0,0x0,0x5,0x18,0xc3,0x18,0xdd,0x0,0x0,0x0,0x7,0xf,0xff,0xff,0xf7,0x0,0x0},
	{0x0,0x3,0xfd,0xff,0xdf,0xff,0x0,0x0,0x0,0x6,0x15,0x43,0x54,0x41,0x0,0x0,0x0,0x5,0xf5,0x5d,0x56,0xdf,0x0,0x0,0x0,0x6,0x35,0x41,0x76,0xc4,0x0,0x0,0x0,0x7,0xd7,0x5b,0xae,0xdf,0x0,0x0,0x0,0x4,0x38,0xdd,0xdc,0x41,0x0,0x0,0x0,0x7,0xef,0xf7,0x77,0xff,0x0,0x0},
	{0x1,0xdf,0xfd,0xff,0x7f,0xff,0xfc,0x0,0x1,0x76,0x37,0x45,0xd8,0xc1,0x4,0x0,0x1,0x6d,0xd2,0x6d,0xb7,0x7b,0x7c,0x0,0x1,0x1c,0x15,0x6c,0x70,0x77,0x10,0x0,0x1,0x6d,0xd7,0x6d,0xb7,0x6f,0x7c,0x0,0x1,0x75,0x55,0x45,0xd5,0x41,0x4,0x0,0x1,0xdf,0x7d,0xff,0x7d,0xff,0xfc,0x0},
	{0x0,0x0,0xff,0xfd,0xfe,0xf8,0x0,0x0,0x0,0x1,0x86,0x37,0x43,0x8c,0x0,0x0,0x0,0x1,0x7d,0xd2,0x5d,0x74,0x0,0x0,0x0,0x1,0x45,0x55,0x43,0x54,0x0,0x0,0x0,0x1,0x7d,0xd7,0x5d,0x74,0x0,0x0,0x0,0x1,0x86,0x35,0x43,0x8c,0x0,0x0,0x0,0x0,0xff,0xfd,0xfe,0xf8,0x0,0x0},
	{0x0,0x0,0x7f,0xbf,0xff,0xf8,0x0,0x0,0x0,0x0,0xc2,0xa8,0x82,0x8,0x0,0x0,0x0,0x0,0xbe,0xad,0xee,0xf8,0x0,0x0,0x0,0x0,0xc6,0xad,0x2a,0x20,0x0,0x0,0x0,0x0,0xfa,0xed,0xaa,0xf8,0x0,0x0,0x0,0x0,0x87,0x18,0xaa,0x8,0x0,0x0,0x0,0x0,0xfd,0xff,0xbb,0xf8,0x0,0x0},
	{0xff,0xff,0xff,0xff,0xf7,0xfb,0xef,0xf8,0x86,0xc,0x31,0x86,0x1c,0x6e,0xba,0x8,0xba,0xfb,0xee,0xba,0xeb,0xa6,0x9a,0xf8,0xaa,0x2c,0x6a,0x82,0xaa,0xaa,0xaa,0x20,0xba,0xff,0xae,0xb6,0xeb,0xac,0xb2,0xf8,0x86,0x8,0x71,0xba,0x1c,0x6e,0xba,0x8,0xff,0xff,0xdf,0xef,0xf7,0xfb,0xef,0xf8},
	{0xff,0x8f,0xef,0xfb,0xff,0xff,0xff,0xb8,0x82,0x88,0xba,0x2e,0xc6,0x8,0xc6,0xe8,0xbe,0x8d,0x93,0x66,0xbb,0xbd,0xba,0x68,0x8a,0x85,0xab,0x6a,0x82,0xa5,0xaa,0xa8,0xbe,0xfd,0xbb,0x6c,0xba,0xad,0xba,0xc8,0x82,0x8,0xaa,0x2e,0xaa,0xa8,0xc6,0xe8,0xff,0xff,0xef,0xfb,0xee,0xef,0xff,0xb8},
	{0x1f,0xff,0xff,0xff,0xff,0xff,0xbf,0xe0,0x31,0x86,0x8,0xc2,0x8,0xc6,0xa8,0x20,0x2e,0xbb,0xbd,0xbf,0xbd,0xba,0xab,0xe0,0x20,0x82,0xa5,0xc6,0xa5,0xaa,0xa8,0x80,0x2e,0xb6,0xad,0xfa,0xad,0xb6,0xeb,0xe0,0x2a,0xba,0xa8,0x86,0xa8,0xcb,0x18,0x20,0x3b,0xee,0xef,0xfc,0xef,0xff,0xff,0xe0},
	{0x0,0x0,0xff,0x7f,0xff,0xfc,0x0,0x0,0x0,0x1,0x8d,0x50,0x43,0x4,0x0,0x0,0x0,0x1,0x75,0x5d,0xdd,0x7c,0x0,0x0,0x0,0x1,0x5,0x55,0x41,0x10,0x0,0x0,0x0,0x1,0x75,0xd5,0x5b,0x7c,0x0,0x0,0x0,0x1,0x56,0x35,0x5d,0x4,0x0,0x0,0x0,0x1,0xdf,0xe7,0x77,0xfc,0x0,0x0}};
const unsigned char *TextesSucces[]={"Jouer + de 30 min","Jouer + de 1h 30min","Jouer + de 4h 30min","Faire un 1024","Faire un 2048","Faire un 4096","Atteinde les 7000pts","Atteinde les 42000pts","Atteinde les 77000pts","Mourir avant 600pts","Mourir avant 300pts","Mourir avant 150pts","Enchainer 5 fusions","Enchainer 8 fusions","Enchainer 11 fusions","3 fusions dans l'ordre","6 fusions dans l'ordre","9 fusions dans l'ordre","3 fusions desordonnees","4 fusions desordonnees","5 fusions desordonnees","2 fusions en meme temps","4 fusions en meme temps","6 fusions en meme temps","Rectangle 3*4","Triangle rectangle 4*4","Carre 2*2","Spawn de 2 '4' d'affile","Gagner a 6min 42sec pile","Obtenir tous les succes"};

const unsigned char ImMedailles[31][195]={
	{0x0,0xf,0xff,0xe0,0x0,0x74,0x3e,0x0,0xf8,0x5c,0x60,0xf1,0xff,0x1e,0xc,0x41,0xce,0xaa,0xe7,0x4,0x3,0xb5,0x55,0x5b,0x80,0x46,0x6a,0xaa,0xac,0xc4,0xd,0xd5,0x7d,0x57,0x60,0x1a,0xab,0xc7,0xaa,0xb0,0x3b,0x5e,0x10,0xf5,0xb8,0x36,0xb0,0xfe,0x1a,0xd8,0x6d,0x67,0x83,0xcd,0x6c,0x6a,0xcf,0x1,0xe6,0xac,0xd5,0x9e,0x0,0xf3,0x56,0xda,0xbc,0x38,0x7a,0xb6,0xd5,0xbc,0x7c,0x7b,0x56,0xab,0x3c,0x7c,0x79,0xaa,0xb5,0x7c,0x38,0x7d,0x5a,0xab,0x7e,0x38,0x7d,0xaa,0xb6,0x7f,0xf0,0xfc,0xda,0xaa,0xff,0xf1,0xfe,0xaa,0xb6,0x7f,0xe3,0xfc,0xda,0xab,0x7f,0xe3,0xfd,0xaa,0xb5,0x7f,0xe7,0xfd,0x5a,0xab,0x3f,0xef,0xf9,0xaa,0xd5,0xbf,0xff,0xfb,0x56,0xda,0xbf,0xef,0xfa,0xb6,0xd5,0x9f,0xc7,0xf3,0x56,0x6a,0xcf,0xc7,0xe6,0xac,0x6d,0x67,0xef,0xcd,0x6c,0x36,0xb0,0xfe,0x1a,0xd8,0x3b,0x5e,0x10,0xf5,0xb8,0x1a,0xab,0xc7,0xaa,0xb0,0xd,0xd5,0x7d,0x57,0x60,0x46,0x6a,0xaa,0xac,0xc4,0x3,0xb5,0x55,0x5b,0x80,0x41,0xce,0xaa,0xe7,0x4,0x60,0xf1,0xff,0x1e,0xc,0x74,0x3e,0x0,0xf8,0x5c,0x0,0xf,0xff,0xe0,0x0},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xcf,0xff,0xe7,0x1a,0xe3,0xbf,0x3f,0xfb,0x8e,0xc6,0x7e,0x7e,0x3c,0xc6,0x8d,0xe7,0xef,0x4f,0x62,0x9b,0xcb,0xc7,0xa7,0xb2,0x3b,0x8d,0xe3,0xd3,0xb8,0x37,0x3e,0xf1,0xd9,0xd8,0x6e,0x6d,0xe3,0xcc,0xec,0x6c,0xcb,0xc7,0x84,0x6c,0xdd,0x7,0xef,0xdf,0x76,0xda,0xef,0xff,0xee,0xf6,0xd9,0xff,0x1,0xf5,0xf6,0xbb,0xfe,0x0,0xfb,0xba,0xbf,0xbd,0xff,0x7f,0x9a,0xbf,0x1d,0x11,0x7f,0xda,0xbe,0xd,0xd5,0x6e,0xfa,0xbc,0x44,0x95,0x44,0x7a,0xbe,0xed,0xd5,0x60,0xfa,0xb7,0xfd,0x11,0x71,0xfa,0xb3,0xfd,0xff,0x7b,0xfa,0xbb,0xbe,0x0,0xff,0xba,0xdf,0x5f,0x1,0xff,0x36,0xde,0xef,0xff,0xee,0xb6,0xdd,0xf7,0xef,0xc1,0x76,0x6c,0x43,0xc7,0xa6,0x6c,0x6e,0x67,0x8f,0x6c,0xec,0x37,0x37,0x1e,0xf9,0xd8,0x3b,0x97,0x8f,0x63,0xb8,0x9b,0xcb,0xc7,0xa7,0xb2,0x8d,0xe5,0xef,0xcf,0x62,0xc6,0x78,0xfc,0xfc,0xc6,0xe3,0xbf,0xf9,0xfb,0x8e,0xb1,0xcf,0xff,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xcf,0xff,0xe7,0x1a,0xe3,0xbf,0x3f,0xfb,0x8e,0xc6,0x7e,0x7e,0x3c,0xc6,0x8d,0xe7,0xef,0x4f,0x62,0x9b,0xcb,0xc7,0xa7,0xb2,0x3b,0x8d,0xe3,0xd3,0xb8,0x37,0x3e,0xf1,0xd9,0xd8,0x6e,0x6d,0xe3,0xcc,0xec,0x6c,0xcb,0xc7,0x84,0x6c,0xdd,0x7,0xef,0xdf,0x76,0xda,0xef,0x83,0xee,0xf6,0xd9,0xff,0x1,0xf5,0xf6,0xbb,0xfe,0x0,0xfb,0xba,0xbf,0xbd,0xff,0x7f,0x9a,0xbf,0x19,0x11,0x3f,0xda,0xbe,0x9,0x55,0x2e,0xfa,0xbc,0x41,0x15,0x4,0x7a,0xbe,0xe9,0xd5,0x20,0xfa,0xb7,0xf9,0x11,0x31,0xfa,0xb3,0xfd,0xff,0x7b,0xfa,0xbb,0xbe,0x0,0xff,0xba,0xdf,0x5f,0x1,0xff,0x36,0xde,0xef,0x83,0xee,0xb6,0xdd,0xf7,0xef,0xc1,0x76,0x6c,0x43,0xc7,0xa6,0x6c,0x6e,0x67,0x8f,0x6c,0xec,0x37,0x37,0x1e,0xf9,0xd8,0x3b,0x97,0x8f,0x63,0xb8,0x9b,0xcb,0xc7,0xa7,0xb2,0x8d,0xe5,0xef,0xcf,0x62,0xc6,0x78,0xfc,0xfc,0xc6,0xe3,0xbf,0xf9,0xfb,0x8e,0xb1,0xcf,0xff,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xcf,0xff,0xe7,0x1a,0xe3,0xbf,0x3f,0xfb,0x8e,0xc6,0x7e,0x7e,0x3c,0xc6,0x8d,0xe7,0xef,0x4f,0x62,0x9b,0xcb,0xc7,0xa7,0xb2,0x3b,0x8d,0xe3,0xd3,0xb8,0x37,0x3e,0xf1,0xd9,0xd8,0x6e,0x6d,0xe3,0xcc,0xec,0x6c,0xcb,0xc7,0x84,0x6c,0xdd,0x7,0x1,0xdf,0x76,0xda,0xee,0x0,0xee,0xf6,0xd9,0xfc,0x0,0x75,0xf6,0xbb,0xf8,0x0,0x3b,0xba,0xbf,0xb7,0xff,0xdf,0x9a,0xbf,0x14,0x44,0x5f,0xda,0xbe,0x7,0x75,0x4e,0xfa,0xbc,0x44,0x65,0x44,0x7a,0xbe,0xe5,0xf5,0x40,0xfa,0xb7,0xf4,0x54,0x51,0xfa,0xb3,0xf7,0xdf,0xdb,0xfa,0xbb,0xb8,0x0,0x3f,0xba,0xdf,0x5c,0x0,0x7f,0x36,0xde,0xee,0x0,0xee,0xb6,0xdd,0xf7,0x1,0xc1,0x76,0x6c,0x43,0xc7,0xa6,0x6c,0x6e,0x67,0x8f,0x6c,0xec,0x37,0x37,0x1e,0xf9,0xd8,0x3b,0x97,0x8f,0x63,0xb8,0x9b,0xcb,0xc7,0xa7,0xb2,0x8d,0xe5,0xef,0xcf,0x62,0xc6,0x78,0xfc,0xfc,0xc6,0xe3,0xbf,0xf9,0xfb,0x8e,0xb1,0xcf,0xff,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xce,0x0,0xe7,0x1a,0xe3,0xb0,0xfe,0x1b,0x8e,0xc6,0x46,0xfe,0xc4,0xc6,0x8d,0x9e,0x7c,0xf3,0x62,0x9a,0x3f,0x7d,0xf8,0xb2,0x3a,0x3f,0x39,0xf8,0xb8,0x34,0x9f,0xbb,0xf2,0x58,0x69,0xcf,0x93,0xe7,0x2c,0x6b,0xe3,0xd7,0x8f,0xac,0xd0,0x0,0x0,0x0,0x16,0xd3,0xff,0xff,0xff,0x96,0xd7,0xff,0xff,0xff,0xd6,0xae,0x0,0x0,0x0,0xea,0xbe,0xf3,0xef,0xbe,0xfa,0xb6,0x92,0x28,0xaa,0xda,0xae,0xd2,0xae,0xaa,0xea,0xb6,0x52,0xa8,0xa2,0xda,0xae,0xda,0xab,0xba,0xea,0xb6,0x8a,0x28,0x8a,0xda,0xbe,0xfb,0xef,0x8e,0xfa,0xae,0x0,0x0,0x0,0xea,0xd7,0xff,0xff,0xff,0xd6,0xd3,0xff,0xff,0xff,0x96,0xd0,0x0,0x0,0x0,0x16,0x6b,0xe3,0xd7,0x8f,0xac,0x69,0xcf,0x93,0xe7,0x2c,0x34,0x9f,0xbb,0xf2,0x58,0x3a,0x3f,0x39,0xf8,0xb8,0x9a,0x3f,0x7d,0xf8,0xb2,0x8d,0x9e,0x7c,0xf3,0x62,0xc6,0x46,0xfe,0xc4,0xc6,0xe3,0xb0,0xfe,0x1b,0x8e,0xb1,0xce,0x0,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xce,0x0,0xe7,0x1a,0xe3,0xb0,0xfe,0x1b,0x8e,0xc6,0x46,0xc6,0xc4,0xc6,0x8d,0x9e,0x6c,0xf3,0x62,0x9a,0x33,0x6d,0x98,0xb2,0x3a,0x3b,0x39,0xb8,0xb8,0x34,0x9d,0xbb,0x72,0x58,0x69,0xce,0x92,0xe7,0x2c,0x6b,0xe3,0xd7,0x8f,0xac,0xd0,0x0,0x0,0x0,0x16,0xd3,0xff,0xff,0xff,0x96,0xd7,0xff,0xff,0xff,0xd6,0xae,0x0,0x0,0x0,0xea,0xbe,0xfb,0xef,0xbe,0xfa,0xb6,0x8a,0x2a,0xa2,0xda,0xae,0xea,0xaa,0xaa,0xea,0xb6,0x8a,0xa8,0xa2,0xda,0xae,0xba,0xae,0xaa,0xea,0xb6,0x8a,0x22,0xa2,0xda,0xbe,0xfb,0xe3,0xbe,0xfa,0xae,0x0,0x0,0x0,0xea,0xd7,0xff,0xff,0xff,0xd6,0xd3,0xff,0xff,0xff,0x96,0xd0,0x0,0x0,0x0,0x16,0x6b,0xe3,0xd7,0x8f,0xac,0x69,0xce,0x92,0xe7,0x2c,0x34,0x9d,0xbb,0x72,0x58,0x3a,0x3b,0x39,0xb8,0xb8,0x9a,0x33,0x6d,0x98,0xb2,0x8d,0x9e,0x6c,0xf3,0x62,0xc6,0x46,0xc6,0xc4,0xc6,0xe3,0xb0,0xfe,0x1b,0x8e,0xb1,0xce,0x0,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xce,0x0,0xe7,0x1a,0xe3,0xb0,0xfe,0x1b,0x8e,0xc6,0x46,0xaa,0xc4,0xc6,0x8d,0x9a,0x54,0xb3,0x62,0x9a,0x35,0x55,0x58,0xb2,0x3a,0x2d,0x29,0x68,0xb8,0x34,0x92,0xaa,0x92,0x58,0x69,0x4c,0x92,0x65,0x2c,0x6b,0xe3,0xd7,0x8f,0xac,0xd0,0x0,0x0,0x0,0x16,0xd3,0xff,0xff,0xff,0x96,0xd7,0xff,0xff,0xff,0xd6,0xae,0x0,0x0,0x0,0xea,0xbe,0xfb,0xef,0xbe,0xfa,0xb6,0xaa,0x28,0xa2,0xda,0xae,0xaa,0xaa,0xae,0xea,0xb6,0x8a,0xa8,0xa2,0xda,0xae,0xea,0xae,0xaa,0xea,0xb6,0x2a,0x28,0xa2,0xda,0xbe,0x3b,0xef,0xbe,0xfa,0xae,0x0,0x0,0x0,0xea,0xd7,0xff,0xff,0xff,0xd6,0xd3,0xff,0xff,0xff,0x96,0xd0,0x0,0x0,0x0,0x16,0x6b,0xe3,0xd7,0x8f,0xac,0x69,0x4c,0x92,0x65,0x2c,0x34,0x92,0xaa,0x92,0x58,0x3a,0x2d,0x29,0x68,0xb8,0x9a,0x35,0x55,0x58,0xb2,0x8d,0x9a,0x54,0xb3,0x62,0xc6,0x46,0xaa,0xc4,0xc6,0xe3,0xb0,0xfe,0x1b,0x8e,0xb1,0xce,0x0,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xce,0x0,0xe7,0x1a,0xe3,0xb0,0xba,0x1b,0x8e,0xc6,0x42,0x28,0x84,0xc6,0x8d,0x88,0x28,0x23,0x62,0x9a,0x28,0x28,0x28,0xb2,0x3a,0x84,0x38,0x42,0xb8,0x34,0x44,0x0,0x44,0x58,0x69,0x0,0xfe,0x1,0x2c,0x68,0x3,0x83,0x80,0x2c,0xd3,0x6,0x0,0xc1,0x96,0xd0,0xcc,0x38,0x66,0x16,0xd4,0x18,0x7c,0x30,0x56,0xa0,0x10,0x0,0x10,0xa,0xa0,0x31,0xff,0x18,0xa,0xae,0x21,0x15,0x8,0xea,0xaa,0x21,0xd5,0x8,0x2a,0xae,0x20,0x93,0x8,0x6a,0xa2,0x20,0xd5,0x8,0x2a,0xae,0x20,0x55,0x8,0xea,0xa0,0x30,0x7f,0x18,0xa,0xa0,0x10,0x0,0x10,0xa,0xd4,0x18,0x7c,0x30,0x56,0xd0,0xcc,0x38,0x66,0x16,0xd3,0x6,0x0,0xc1,0x96,0x68,0x3,0x83,0x80,0x2c,0x69,0x0,0xfe,0x1,0x2c,0x34,0x44,0x0,0x44,0x58,0x3a,0x84,0x38,0x42,0xb8,0x9a,0x28,0x20,0x28,0xb2,0x8d,0x88,0x38,0x23,0x62,0xc6,0x42,0x28,0x84,0xc6,0xe3,0xb0,0xba,0x1b,0x8e,0xb1,0xce,0x0,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xce,0x0,0xe7,0x1a,0xe3,0xb0,0xba,0x1b,0x8e,0xc6,0x42,0x28,0x84,0xc6,0x8d,0x88,0x28,0x23,0x62,0x9a,0x28,0x28,0x28,0xb2,0x3a,0x84,0x38,0x42,0xb8,0x34,0x44,0x0,0x44,0x58,0x69,0x0,0xfe,0x1,0x2c,0x68,0x3,0x83,0x80,0x2c,0xd3,0x6,0x0,0xc1,0x96,0xd0,0xcc,0x7c,0x66,0x16,0xd4,0x18,0xfe,0x30,0x56,0xa0,0x10,0x0,0x10,0xa,0xa0,0x37,0xff,0xd8,0xa,0xae,0x25,0x45,0x48,0xea,0xaa,0x25,0x75,0x48,0x2a,0xae,0x24,0x44,0xc8,0x6a,0xa2,0x27,0x5d,0x48,0x2a,0xae,0x21,0x45,0x48,0xea,0xa0,0x31,0xff,0xd8,0xa,0xa0,0x10,0x0,0x10,0xa,0xd4,0x18,0xfe,0x30,0x56,0xd0,0xcc,0x7c,0x66,0x16,0xd3,0x6,0x0,0xc1,0x96,0x68,0x3,0x83,0x80,0x2c,0x69,0x0,0xfe,0x1,0x2c,0x34,0x44,0x0,0x44,0x58,0x3a,0x84,0x38,0x42,0xb8,0x9a,0x28,0x20,0x28,0xb2,0x8d,0x88,0x38,0x23,0x62,0xc6,0x42,0x28,0x84,0xc6,0xe3,0xb0,0xba,0x1b,0x8e,0xb1,0xce,0x0,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xce,0x0,0xe7,0x1a,0xe3,0xb0,0xba,0x1b,0x8e,0xc6,0x42,0x28,0x84,0xc6,0x8d,0x88,0x28,0x23,0x62,0x9a,0x28,0x28,0x28,0xb2,0x3a,0x84,0x38,0x42,0xb8,0x34,0x44,0x0,0x44,0x58,0x69,0x0,0xfe,0x1,0x2c,0x68,0x3,0x83,0x80,0x2c,0xd3,0x6,0x38,0xc1,0x96,0xd0,0xcc,0xfe,0x66,0x16,0xd4,0x19,0xff,0x30,0x56,0xa0,0x10,0x0,0x10,0xa,0xa0,0x37,0xff,0xd8,0xa,0xae,0x24,0x45,0x48,0xea,0xaa,0x27,0x75,0x48,0x2a,0xae,0x22,0x64,0xc8,0x6a,0xa2,0x23,0x75,0x48,0x2a,0xae,0x21,0x55,0x48,0xea,0xa0,0x31,0xdf,0xd8,0xa,0xa0,0x10,0x0,0x10,0xa,0xd4,0x19,0xff,0x30,0x56,0xd0,0xcc,0xfe,0x66,0x16,0xd3,0x6,0x38,0xc1,0x96,0x68,0x3,0x83,0x80,0x2c,0x69,0x0,0xfe,0x1,0x2c,0x34,0x44,0x0,0x44,0x58,0x3a,0x84,0x38,0x42,0xb8,0x9a,0x28,0x20,0x28,0xb2,0x8d,0x88,0x38,0x23,0x62,0xc6,0x42,0x28,0x84,0xc6,0xe3,0xb0,0xba,0x1b,0x8e,0xb1,0xce,0x0,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xcf,0x55,0xe7,0x1a,0xe3,0xba,0xaa,0xbb,0x8e,0xc6,0x55,0x55,0x54,0xc6,0x8d,0xff,0xef,0xff,0x62,0x9b,0xc0,0x7c,0x7,0xb2,0x3b,0x1f,0x11,0xf1,0xb8,0x36,0x6f,0xc7,0x8c,0xd8,0x6c,0xf3,0xab,0x7e,0x6c,0x6d,0xfd,0xbd,0x7d,0x6c,0xd9,0x7b,0xff,0xfb,0x36,0xdb,0xbf,0xff,0xfb,0xb6,0xdb,0xdf,0xff,0xff,0xb6,0xab,0xdf,0xff,0xff,0xaa,0xbb,0xff,0xff,0xff,0xba,0xab,0xfc,0x44,0x7b,0xaa,0xb9,0x7d,0xd5,0x7b,0x3a,0xad,0x7c,0x55,0x7d,0x6a,0xb4,0xbd,0x55,0x7e,0x5a,0xae,0xbc,0x44,0x7e,0xea,0xb6,0x7f,0xff,0xfc,0xda,0xbb,0x3f,0xff,0xe9,0xaa,0xd5,0x9f,0xff,0x93,0x56,0xda,0xcd,0xff,0xe6,0xb6,0xd5,0x66,0xff,0xcd,0x56,0x6a,0xb3,0x7b,0x9a,0xac,0x6d,0x59,0x7b,0x35,0x6c,0x36,0xac,0xf6,0x6a,0xd8,0x3b,0x56,0x74,0xd5,0xb8,0x9a,0xab,0x39,0xaa,0xb2,0x8d,0xd5,0x93,0x57,0x62,0xc6,0x6a,0xc6,0xac,0xc6,0xe3,0xbd,0x7d,0x5b,0x8e,0xb1,0xce,0xaa,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xcf,0x55,0xe7,0x1a,0xe3,0xba,0xaa,0xbb,0x8e,0xc6,0x55,0x55,0x54,0xc6,0x8d,0xff,0xef,0xff,0x62,0x9b,0xc0,0x7c,0x7,0xb2,0x3b,0x1f,0x11,0xf1,0xb8,0x36,0x6f,0xc7,0x8c,0xd8,0x6c,0xf3,0xab,0x7e,0x6c,0x6d,0xfd,0xbd,0x7d,0x6c,0xd9,0x7a,0xdb,0xbb,0x36,0xdb,0xa6,0xeb,0xbb,0xb6,0xdb,0xdf,0xff,0xf7,0xb6,0xab,0xdf,0xff,0xf7,0xaa,0xbb,0xbf,0xff,0xfb,0xba,0xab,0xbc,0x44,0x7b,0xaa,0xb9,0x5f,0x55,0x7b,0x3a,0xad,0x7e,0x55,0x75,0x6a,0xb4,0xbf,0x55,0x7e,0x5a,0xae,0xbc,0x44,0x7e,0xea,0xb6,0x7f,0xff,0xfc,0xda,0xbb,0x3f,0xff,0xe9,0xaa,0xd5,0x9f,0xff,0x13,0x56,0xda,0xcd,0xae,0xe6,0xb6,0xd5,0x66,0xb7,0x4d,0x56,0x6a,0xb3,0x7b,0x9a,0xac,0x6d,0x59,0x7b,0x35,0x6c,0x36,0xac,0xf6,0x6a,0xd8,0x3b,0x56,0x74,0xd5,0xb8,0x9a,0xab,0x39,0xaa,0xb2,0x8d,0xd5,0x93,0x57,0x62,0xc6,0x6a,0xc6,0xac,0xc6,0xe3,0xbd,0x7d,0x5b,0x8e,0xb1,0xce,0xaa,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xcf,0x55,0xe7,0x1a,0xe3,0xba,0xaa,0xbb,0x8e,0xc6,0x55,0x55,0x54,0xc6,0x8d,0xff,0xef,0xff,0x62,0x9b,0xc0,0x7c,0x7,0xb2,0x3b,0x1f,0x11,0xf1,0xb8,0x36,0x6f,0xc7,0x8c,0xd8,0x6c,0xf3,0xab,0x7e,0x6c,0x6d,0xfd,0xbd,0x7d,0x6c,0xd9,0x7a,0xdb,0xbb,0x36,0xdb,0xa6,0xeb,0xbb,0xb6,0xdb,0xdf,0x6b,0xb7,0xb6,0xab,0xdf,0xb7,0x77,0xaa,0xbb,0xbf,0xff,0xfb,0xba,0xab,0xbc,0xc4,0x7b,0xaa,0xb9,0x4e,0xdd,0x7b,0x3a,0xad,0x76,0xc5,0x65,0x6a,0xb4,0xbe,0xf5,0x5e,0x5a,0xae,0xbc,0x44,0x7e,0xea,0xb6,0x7f,0xff,0xfc,0xda,0xbb,0x3b,0xdd,0xe9,0xaa,0xd5,0x9d,0xad,0x13,0x56,0xda,0xcd,0xae,0xe6,0xb6,0xd5,0x66,0xb7,0x4d,0x56,0x6a,0xb3,0x7b,0x9a,0xac,0x6d,0x59,0x7b,0x35,0x6c,0x36,0xac,0xf6,0x6a,0xd8,0x3b,0x56,0x74,0xd5,0xb8,0x9a,0xab,0x39,0xaa,0xb2,0x8d,0xd5,0x93,0x57,0x62,0xc6,0x6a,0xc6,0xac,0xc6,0xe3,0xbd,0x7d,0x5b,0x8e,0xb1,0xce,0xaa,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xce,0x0,0xe7,0x1a,0xe3,0xb0,0x44,0x1b,0x8e,0xc6,0x42,0x0,0x84,0xc6,0x8d,0x80,0x92,0x3,0x62,0x9a,0x24,0x92,0x48,0xb2,0x3a,0x7,0x6d,0xc0,0xb8,0x34,0x75,0x29,0x5c,0x58,0x69,0x2c,0xc6,0x69,0x2c,0x68,0xe2,0x44,0x8e,0x2c,0xd3,0x90,0x0,0x13,0x96,0xd1,0x63,0xff,0x8d,0x16,0xd3,0x4,0x0,0x41,0x96,0xa0,0x5,0xff,0x40,0xa,0xaf,0xed,0x83,0x6f,0xea,0xab,0xb9,0x9f,0x3b,0xaa,0xad,0x7d,0x9f,0x7d,0x6a,0xae,0xff,0x87,0xfe,0xea,0xad,0x7d,0xf3,0x7d,0x6a,0xab,0xb9,0xb3,0x3b,0xaa,0xaf,0xed,0xc7,0x6f,0xea,0xa0,0x5,0xff,0x40,0xa,0xd3,0x4,0x0,0x41,0x96,0xd1,0x63,0xff,0x8d,0x16,0xd3,0x90,0x0,0x13,0x96,0x68,0xe2,0x44,0x8e,0x2c,0x69,0x2c,0xc6,0x69,0x2c,0x34,0x75,0x29,0x5c,0x58,0x3a,0x7,0x6d,0xc0,0xb8,0x9a,0x24,0x92,0x48,0xb2,0x8d,0x80,0x92,0x3,0x62,0xc6,0x42,0x0,0x84,0xc6,0xe3,0xb0,0x44,0x1b,0x8e,0xb1,0xce,0x0,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xce,0x0,0xe7,0x1a,0xe3,0xb0,0x44,0x1b,0x8e,0xc6,0x41,0x11,0x4,0xc6,0x8d,0x8d,0x93,0x63,0x62,0x9a,0x2b,0x6d,0xa8,0xb2,0x3a,0xb,0x29,0xa0,0xb8,0x34,0xe9,0x45,0x2e,0x58,0x68,0x58,0xc6,0x34,0x2c,0x6b,0xc4,0x44,0x47,0xac,0xd1,0x20,0x0,0x9,0x16,0xd7,0x33,0xff,0x99,0xd6,0xd4,0x84,0x0,0x42,0x56,0xa0,0x5,0xff,0x40,0xa,0xaf,0xed,0xc7,0x6f,0xea,0xab,0xb9,0x93,0x3b,0xaa,0xad,0x7d,0x93,0x7d,0x6a,0xae,0xff,0xc7,0xfe,0xea,0xad,0x7d,0x93,0x7d,0x6a,0xab,0xb9,0x93,0x3b,0xaa,0xaf,0xed,0xc7,0x6f,0xea,0xa0,0x5,0xff,0x40,0xa,0xd4,0x84,0x0,0x42,0x56,0xd7,0x33,0xff,0x99,0xd6,0xd1,0x20,0x0,0x9,0x16,0x6b,0xc4,0x44,0x47,0xac,0x68,0x58,0xc6,0x34,0x2c,0x34,0xe9,0x45,0x2e,0x58,0x3a,0xb,0x29,0xa0,0xb8,0x9a,0x2b,0x6d,0xa8,0xb2,0x8d,0x8d,0x93,0x63,0x62,0xc6,0x41,0x11,0x4,0xc6,0xe3,0xb0,0x44,0x1b,0x8e,0xb1,0xce,0x0,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xce,0x0,0xe7,0x1a,0xe3,0xb0,0x54,0x1b,0x8e,0xc6,0x43,0x11,0x84,0xc6,0x8d,0x9a,0xaa,0xb3,0x62,0x9a,0x16,0x6c,0xd0,0xb2,0x3a,0xf2,0x44,0x9e,0xb8,0x34,0x99,0x45,0x32,0x58,0x68,0x48,0xc6,0x24,0x2c,0x6b,0xc4,0x44,0x47,0xac,0xd1,0x38,0x0,0x39,0x16,0xd2,0x93,0xff,0x92,0x96,0xd7,0xc4,0x0,0x47,0xd6,0xa0,0x5,0xff,0x40,0xa,0xaf,0xed,0xbb,0x6f,0xea,0xab,0xb9,0x33,0x3b,0xaa,0xad,0x7d,0x33,0x7d,0x6a,0xae,0xff,0xbb,0xfe,0xea,0xad,0x7d,0xbb,0x7d,0x6a,0xab,0xb9,0x11,0x3b,0xaa,0xaf,0xed,0x11,0x6f,0xea,0xa0,0x5,0xff,0x40,0xa,0xd7,0xc4,0x0,0x47,0xd6,0xd2,0x93,0xff,0x92,0x96,0xd1,0x38,0x0,0x39,0x16,0x6b,0xc4,0x44,0x47,0xac,0x68,0x48,0xc6,0x24,0x2c,0x34,0x99,0x45,0x32,0x58,0x3a,0xf2,0x44,0x9e,0xb8,0x9a,0x16,0x6c,0xd0,0xb2,0x8d,0x9a,0xaa,0xb3,0x62,0xc6,0x43,0x11,0x84,0xc6,0xe3,0xb0,0x54,0x1b,0x8e,0xb1,0xce,0x0,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xce,0x0,0xe7,0x1a,0xe3,0xb0,0xfe,0x1b,0x8e,0xc6,0x47,0xff,0xc4,0xc6,0x8d,0x9c,0x0,0x73,0x62,0x9a,0x30,0x0,0x18,0xb2,0x3a,0xe0,0x0,0xe,0xb8,0x34,0x80,0x0,0x2,0x58,0x69,0x80,0x0,0x3,0x2c,0x6b,0x7,0xff,0xc1,0xac,0xd2,0x9,0x55,0x20,0x96,0xd6,0x13,0xff,0x90,0xd6,0xd4,0x14,0xaa,0x50,0x56,0xa0,0x1d,0xff,0x70,0xa,0xaf,0xed,0xc7,0x6f,0xea,0xab,0xb9,0xb3,0x3b,0xaa,0xad,0x6d,0xf3,0x6d,0x6a,0xae,0xc7,0xe7,0xc6,0xea,0xad,0x6d,0xf3,0x6d,0x6a,0xab,0xb9,0xb3,0x3b,0xaa,0xaf,0xed,0xc7,0x6f,0xea,0xa0,0x1d,0xff,0x70,0xa,0xd4,0x14,0xaa,0x50,0x56,0xd6,0x13,0xff,0x90,0xd6,0xd2,0x9,0x55,0x20,0x96,0x6b,0x7,0xff,0xc1,0xac,0x69,0x80,0x0,0x3,0x2c,0x34,0x80,0x0,0x2,0x58,0x3a,0xe0,0x0,0xe,0xb8,0x9a,0x30,0x0,0x18,0xb2,0x8d,0x9c,0x0,0x73,0x62,0xc6,0x47,0xff,0xc4,0xc6,0xe3,0xb0,0xfe,0x1b,0x8e,0xb1,0xce,0x0,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xce,0x0,0xe7,0x1a,0xe3,0xb0,0xfe,0x1b,0x8e,0xc6,0x47,0xff,0xc4,0xc6,0x8d,0x9c,0x0,0x73,0x62,0x9a,0x30,0x0,0x18,0xb2,0x3a,0xe0,0x0,0xe,0xb8,0x34,0x8f,0xff,0xe2,0x58,0x69,0x92,0xaa,0x93,0x2c,0x6b,0x27,0xff,0xc9,0xac,0xd2,0x49,0x55,0x24,0x96,0xd6,0x53,0xff,0x94,0xd6,0xd4,0x74,0xaa,0x5c,0x56,0xa0,0x5d,0xff,0x74,0xa,0xaf,0xed,0xc7,0x6f,0xea,0xab,0xb9,0x9b,0x3b,0xaa,0xad,0x6d,0x9f,0x6d,0x6a,0xae,0xc7,0x87,0xc6,0xea,0xad,0x6d,0x93,0x6d,0x6a,0xab,0xb9,0x93,0x3b,0xaa,0xaf,0xed,0xc7,0x6f,0xea,0xa0,0x5d,0xff,0x74,0xa,0xd4,0x74,0xaa,0x5c,0x56,0xd6,0x53,0xff,0x94,0xd6,0xd2,0x49,0x55,0x24,0x96,0x6b,0x27,0xff,0xc9,0xac,0x69,0x92,0xaa,0x93,0x2c,0x34,0x8f,0xff,0xe2,0x58,0x3a,0xe0,0x0,0xe,0xb8,0x9a,0x30,0x0,0x18,0xb2,0x8d,0x9c,0x0,0x73,0x62,0xc6,0x47,0xff,0xc4,0xc6,0xe3,0xb0,0xfe,0x1b,0x8e,0xb1,0xce,0x0,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xce,0x0,0xe7,0x1a,0xe3,0xb0,0xfe,0x1b,0x8e,0xc6,0x47,0xff,0xc4,0xc6,0x8d,0x80,0x0,0x3,0x62,0x9a,0x3f,0xff,0xf8,0xb2,0x3a,0x65,0x55,0x4c,0xb8,0x34,0xcf,0xff,0xe6,0x58,0x69,0x92,0xaa,0x93,0x2c,0x69,0x27,0xff,0xc9,0x2c,0xd1,0x49,0x55,0x25,0x16,0xd5,0xd3,0xff,0x97,0x56,0xd5,0x74,0xaa,0x5d,0x56,0xa1,0xdd,0xff,0x77,0xa,0xaf,0xed,0xc7,0x6f,0xea,0xab,0xb9,0x93,0x3b,0xaa,0xad,0x6d,0x93,0x6d,0x6a,0xae,0xc7,0xc3,0xc6,0xea,0xad,0x6d,0xf3,0x6d,0x6a,0xab,0xb9,0xb3,0x3b,0xaa,0xaf,0xed,0xc7,0x6f,0xea,0xa1,0xdd,0xff,0x77,0xa,0xd5,0x74,0xaa,0x5d,0x56,0xd5,0xd3,0xff,0x97,0x56,0xd1,0x49,0x55,0x25,0x16,0x69,0x27,0xff,0xc9,0x2c,0x69,0x92,0xaa,0x93,0x2c,0x34,0xcf,0xff,0xe6,0x58,0x3a,0x65,0x55,0x4c,0xb8,0x9a,0x3f,0xff,0xf8,0xb2,0x8d,0x80,0x0,0x3,0x62,0xc6,0x47,0xff,0xc4,0xc6,0xe3,0xb0,0xfe,0x1b,0x8e,0xb1,0xce,0x0,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xce,0x0,0xe7,0x1a,0xe3,0xb0,0x3f,0x1b,0x8e,0xc6,0x42,0xa1,0xe4,0xc6,0x8d,0x95,0x2e,0x3b,0x62,0x9a,0x2a,0xab,0xcc,0xb2,0x3a,0x55,0x28,0x74,0xb8,0x34,0x0,0x28,0x14,0x58,0x6b,0xff,0xef,0xf4,0x2c,0x6a,0x0,0x82,0x5,0x2c,0xd2,0xff,0xc7,0xfc,0x96,0xd2,0x80,0x6c,0x1,0x56,0xd2,0xaa,0x38,0xaa,0x96,0xa2,0x84,0xfe,0x40,0xa,0xae,0xe9,0xc7,0x2f,0xea,0xab,0xa5,0xb3,0x4b,0xaa,0xad,0x69,0xf3,0x2d,0x6a,0xae,0xe5,0xe7,0x4e,0xea,0xad,0x69,0xf3,0x2d,0x6a,0xab,0xa5,0xb3,0x4b,0xaa,0xaf,0xe9,0xc7,0x2e,0xea,0xa0,0x4,0xfe,0x42,0x8a,0xd2,0xaa,0x38,0xaa,0x96,0xd5,0x0,0x6c,0x2,0x96,0xd2,0x7f,0xc7,0xfe,0x96,0x69,0x40,0x82,0x0,0xac,0x68,0x5f,0xef,0xff,0xac,0x34,0x50,0x28,0x0,0x58,0x3a,0x5c,0x29,0x54,0xb8,0x9a,0x67,0xaa,0xa8,0xb2,0x8d,0xb8,0xe9,0x53,0x62,0xc6,0x4f,0xa,0x84,0xc6,0xe3,0xb1,0xf8,0x1b,0x8e,0xb1,0xce,0x0,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xce,0x0,0xe7,0x1a,0xe3,0xb0,0x3f,0x1b,0x8e,0xc6,0x42,0xa1,0xe4,0xc6,0x8d,0x95,0x2e,0x3b,0x62,0x9a,0x2a,0xab,0xcc,0xb2,0x3a,0x55,0x28,0x74,0xb8,0x34,0xa0,0x28,0x14,0x58,0x69,0x4f,0xef,0xf4,0x2c,0x68,0x8,0x82,0x5,0x2c,0xd3,0xfb,0xc7,0xfc,0x96,0xd2,0xa,0x6c,0x21,0x56,0xd2,0xfb,0xff,0xaa,0x96,0xa2,0x8a,0xfe,0xa0,0xa,0xae,0xeb,0xe3,0xaf,0xea,0xab,0xab,0xc3,0xab,0xaa,0xad,0x6b,0x93,0xad,0x6a,0xae,0xeb,0x93,0xae,0xea,0xad,0x6b,0x83,0xad,0x6a,0xab,0xab,0xf3,0xab,0xaa,0xaf,0xeb,0xf3,0xae,0xea,0xa0,0xa,0xfe,0xa2,0x8a,0xd2,0xab,0xff,0xbe,0x96,0xd5,0x8,0x6c,0xa0,0x96,0xd2,0x7f,0xc7,0xbf,0x96,0x69,0x40,0x82,0x20,0x2c,0x68,0x5f,0xef,0xe5,0x2c,0x34,0x50,0x28,0xa,0x58,0x3a,0x5c,0x29,0x54,0xb8,0x9a,0x67,0xaa,0xa8,0xb2,0x8d,0xb8,0xe9,0x53,0x62,0xc6,0x4f,0xa,0x84,0xc6,0xe3,0xb1,0xf8,0x1b,0x8e,0xb1,0xce,0x0,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xce,0x0,0xe7,0x1a,0xe3,0xb1,0xfa,0x1b,0x8e,0xc6,0x4f,0x8,0x4,0xc6,0x8d,0xb8,0xe9,0xfb,0x62,0x9a,0x67,0xa9,0x8,0xb2,0x3a,0x5c,0x29,0x68,0xb8,0x34,0x50,0x29,0x6a,0x58,0x69,0x5f,0xef,0xe9,0x2c,0x68,0x40,0x82,0xa,0xac,0xd3,0xff,0xc7,0xf9,0x16,0xd2,0x1,0x6d,0x42,0x96,0xd2,0xfd,0x39,0x55,0x56,0xa2,0x85,0xff,0x40,0xa,0xae,0xe5,0x83,0x4f,0xea,0xab,0xa5,0x9f,0x4b,0xaa,0xad,0x65,0x9f,0x4d,0x6a,0xae,0xe5,0x87,0x4e,0xea,0xad,0x65,0xf3,0x4d,0x6a,0xab,0xa5,0xb3,0x4b,0xaa,0xaf,0xe5,0xc7,0x4e,0xea,0xa0,0x5,0xff,0x42,0x8a,0xd5,0x55,0x39,0x7e,0x96,0xd2,0x85,0x6d,0x0,0x96,0xd1,0x3f,0xc7,0xff,0x96,0x6a,0xa0,0x82,0x4,0x2c,0x69,0x2f,0xef,0xf5,0x2c,0x34,0xad,0x28,0x14,0x58,0x3a,0x2d,0x28,0x74,0xb8,0x9a,0x21,0x2b,0xcc,0xb2,0x8d,0xbf,0x2e,0x3b,0x62,0xc6,0x40,0x21,0xe4,0xc6,0xe3,0xb0,0xbf,0x1b,0x8e,0xb1,0xce,0x0,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xce,0x0,0xe7,0x1a,0xe3,0xb0,0xfe,0x1b,0x8e,0xc6,0x4f,0x1,0xe4,0xc6,0x8d,0x8a,0x0,0xa3,0x62,0x9a,0x7e,0x0,0xfc,0xb2,0x3a,0x82,0x38,0x82,0xb8,0x35,0x0,0x28,0x1,0x58,0x69,0x0,0x38,0x1,0x2c,0x69,0x10,0x44,0x11,0x2c,0xd7,0x8,0x82,0x21,0xd6,0xd5,0x5,0x1,0x41,0x56,0xd7,0x82,0x7c,0x83,0xd6,0xa4,0x5,0xff,0x40,0x4a,0xa8,0x9,0xc7,0x20,0x2a,0xa8,0x13,0xb3,0x90,0x2a,0xa8,0xe3,0xf3,0x8e,0x2a,0xa8,0xa3,0xe7,0x8a,0x2a,0xa8,0xe3,0xcf,0x8e,0x2a,0xa8,0x13,0x9b,0x90,0x2a,0xa8,0x9,0x83,0x20,0x2a,0xa4,0x5,0xff,0x40,0x4a,0xd7,0x82,0x7c,0x83,0xd6,0xd5,0x5,0x1,0x41,0x56,0xd7,0x8,0x82,0x21,0xd6,0x69,0x10,0x44,0x11,0x2c,0x69,0x0,0x38,0x1,0x2c,0x35,0x0,0x28,0x1,0x58,0x3a,0x82,0x38,0x82,0xb8,0x9a,0x7e,0x0,0xfc,0xb2,0x8d,0x8a,0x0,0xa3,0x62,0xc6,0x4f,0x1,0xe4,0xc6,0xe3,0xb0,0xfe,0x1b,0x8e,0xb1,0xce,0x0,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xce,0x0,0xe7,0x1a,0xe3,0xb0,0xfe,0x1b,0x8e,0xc6,0x4f,0x1,0xe4,0xc6,0x8d,0x8a,0x0,0xa3,0x62,0x9a,0x7e,0x7c,0xfc,0xb2,0x3a,0x82,0x6c,0x82,0xb8,0x35,0x0,0x54,0x1,0x58,0x69,0x38,0x6c,0x39,0x2c,0x69,0x28,0x7c,0x29,0x2c,0xd7,0x38,0x82,0x39,0xd6,0xd5,0x5,0x1,0x41,0x56,0xd7,0x82,0x7c,0x83,0xd6,0xa4,0x5,0xff,0x40,0x4a,0xa8,0x9,0xe3,0x20,0x2a,0xa9,0xf3,0xc3,0x9f,0x2a,0xa9,0xb3,0x93,0x9b,0x2a,0xa9,0x53,0x93,0x95,0x2a,0xa9,0xb3,0x83,0x9b,0x2a,0xa9,0xf3,0xf3,0x9f,0x2a,0xa8,0x9,0xf3,0x20,0x2a,0xa4,0x5,0xff,0x40,0x4a,0xd7,0x82,0x7c,0x83,0xd6,0xd5,0x5,0x1,0x41,0x56,0xd7,0x38,0x82,0x39,0xd6,0x69,0x28,0x7c,0x29,0x2c,0x69,0x38,0x6c,0x39,0x2c,0x35,0x0,0x54,0x1,0x58,0x3a,0x82,0x6c,0x82,0xb8,0x9a,0x7e,0x7c,0xfc,0xb2,0x8d,0x8a,0x0,0xa3,0x62,0xc6,0x4f,0x1,0xe4,0xc6,0xe3,0xb0,0xfe,0x1b,0x8e,0xb1,0xce,0x0,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xce,0x0,0xe7,0x1a,0xe3,0xb0,0xfe,0x1b,0x8e,0xc6,0x4f,0x1,0xe4,0xc6,0x8d,0x8a,0xfe,0xa3,0x62,0x9a,0x7e,0xc6,0xfc,0xb2,0x3a,0x82,0xba,0x82,0xb8,0x35,0x7c,0xaa,0x7d,0x58,0x69,0x54,0xba,0x55,0x2c,0x69,0x6c,0xc6,0x6d,0x2c,0xd7,0x54,0xfe,0x55,0xd6,0xd5,0x7d,0x1,0x7d,0x56,0xd7,0x82,0x7c,0x83,0xd6,0xa4,0x5,0xff,0x40,0x4a,0xab,0xf9,0xc7,0x3f,0xaa,0xab,0x1b,0x9b,0xb1,0xaa,0xaa,0xeb,0x9f,0xae,0xaa,0xaa,0xab,0x87,0xaa,0xaa,0xaa,0xeb,0x93,0xae,0xaa,0xab,0x1b,0x93,0xb1,0xaa,0xab,0xf9,0xc7,0x3f,0xaa,0xa4,0x5,0xff,0x40,0x4a,0xd7,0x82,0x7c,0x83,0xd6,0xd5,0x7d,0x1,0x7d,0x56,0xd7,0x54,0xfe,0x55,0xd6,0x69,0x6c,0xc6,0x6d,0x2c,0x69,0x54,0xba,0x55,0x2c,0x35,0x7c,0xaa,0x7d,0x58,0x3a,0x82,0xba,0x82,0xb8,0x9a,0x7e,0xc6,0xfc,0xb2,0x8d,0x8a,0xfe,0xa3,0x62,0xc6,0x4f,0x1,0xe4,0xc6,0xe3,0xb0,0xfe,0x1b,0x8e,0xb1,0xce,0x0,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xce,0x0,0xe7,0x1a,0xe3,0xb0,0x7c,0x1b,0x8e,0xc6,0x47,0xc7,0xc4,0xc6,0x8d,0x8c,0x44,0x63,0x62,0x1a,0x77,0xff,0xdc,0xb2,0x3a,0x80,0x0,0x2,0xb8,0x35,0x7f,0xff,0xfd,0x58,0x69,0x7f,0xff,0x85,0x2c,0x69,0x67,0x39,0x85,0x2c,0xd2,0x67,0x39,0x84,0x96,0xd7,0x7f,0xff,0x85,0xd6,0xd5,0x7f,0xff,0xfd,0x56,0xa5,0x7f,0xff,0x85,0x4a,0xa5,0x67,0x39,0x85,0x4a,0xaf,0x67,0x39,0x85,0xea,0xa9,0x7f,0xff,0x85,0x2a,0xa9,0x7f,0xff,0xfd,0x2a,0xa9,0x7f,0xff,0x85,0x2a,0xaf,0x67,0x39,0x85,0xea,0xa5,0x67,0x39,0x85,0x4a,0xa5,0x7f,0xff,0x85,0x4a,0xd5,0x7f,0xff,0xfd,0x56,0xd7,0x7f,0xff,0x85,0xd6,0xd2,0x67,0x39,0x84,0x96,0x69,0x67,0x39,0x85,0x2c,0x69,0x7f,0xff,0x85,0x2c,0x35,0x7f,0xff,0xfd,0x58,0x3a,0x80,0x0,0x2,0xb8,0x9a,0x77,0xff,0xdc,0xb2,0x8d,0x8c,0x44,0x63,0x62,0xc6,0x47,0xc7,0xc4,0xc6,0xe3,0xb0,0x7c,0x1b,0x8e,0xb1,0xce,0x0,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xce,0x0,0xe7,0x1a,0xe3,0xb0,0x7c,0x1b,0x8e,0xc6,0x47,0xc7,0xc4,0xc6,0x8d,0x8c,0x44,0x63,0x62,0x1a,0x77,0xff,0xdc,0xb2,0x3a,0x80,0x0,0x2,0xb8,0x35,0x7f,0xff,0xfd,0x58,0x69,0x7e,0x10,0x85,0x2c,0x69,0x66,0x10,0x85,0x2c,0xd2,0x66,0x10,0x84,0x96,0xd7,0x7e,0x10,0x85,0xd6,0xd5,0x7f,0xff,0xfd,0x56,0xa5,0x7f,0xf0,0x85,0x4a,0xa5,0x67,0x30,0x85,0x4a,0xaf,0x67,0x30,0x85,0xea,0xa9,0x7f,0xf0,0x85,0x2a,0xa9,0x7f,0xff,0xfd,0x2a,0xa9,0x7f,0xff,0x85,0x2a,0xaf,0x67,0x39,0x85,0xea,0xa5,0x67,0x39,0x85,0x4a,0xa5,0x7f,0xff,0x85,0x4a,0xd5,0x7f,0xff,0xfd,0x56,0xd7,0x7f,0xff,0xfd,0xd6,0xd2,0x67,0x39,0xcc,0x96,0x69,0x67,0x39,0xcd,0x2c,0x69,0x7f,0xff,0xfd,0x2c,0x35,0x7f,0xff,0xfd,0x58,0x3a,0x80,0x0,0x2,0xb8,0x9a,0x77,0xff,0xdc,0xb2,0x8d,0x8c,0x44,0x63,0x62,0xc6,0x47,0xc7,0xc4,0xc6,0xe3,0xb0,0x7c,0x1b,0x8e,0xb1,0xce,0x0,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xce,0x0,0xe7,0x1a,0xe3,0xb0,0x7c,0x1b,0x8e,0xc6,0x47,0xc7,0xc4,0xc6,0x8d,0x8c,0x44,0x63,0x62,0x1a,0x77,0xff,0xdc,0xb2,0x3a,0x80,0x0,0x2,0xb8,0x35,0x7f,0xff,0xfd,0x58,0x69,0x42,0x10,0x85,0x2c,0x69,0x42,0x10,0x85,0x2c,0xd2,0x42,0x10,0x84,0x96,0xd7,0x42,0x10,0x85,0xd6,0xd5,0x7f,0xff,0xfd,0x56,0xa5,0x42,0x10,0x85,0x4a,0xa5,0x42,0x10,0x85,0x4a,0xaf,0x42,0x10,0x85,0xea,0xa9,0x42,0x10,0x85,0x2a,0xa9,0x7f,0xff,0xfd,0x2a,0xa9,0x7f,0xf0,0x85,0x2a,0xaf,0x67,0x30,0x85,0xea,0xa5,0x67,0x30,0x85,0x4a,0xa5,0x7f,0xf0,0x85,0x4a,0xd5,0x7f,0xff,0xfd,0x56,0xd7,0x7f,0xf0,0x85,0xd6,0xd2,0x67,0x30,0x84,0x96,0x69,0x67,0x30,0x85,0x2c,0x69,0x7f,0xf0,0x85,0x2c,0x35,0x7f,0xff,0xfd,0x58,0x3a,0x80,0x0,0x2,0xb8,0x9a,0x77,0xff,0xdc,0xb2,0x8d,0x8c,0x44,0x63,0x62,0xc6,0x47,0xc7,0xc4,0xc6,0xe3,0xb0,0x7c,0x1b,0x8e,0xb1,0xce,0x0,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xce,0x0,0xe7,0x1a,0xe3,0xb1,0xef,0x1b,0x8e,0xc6,0x43,0xff,0x84,0xc6,0x8d,0x97,0x3f,0xd3,0x62,0x9a,0x26,0xff,0xc8,0xb2,0x3a,0x96,0xf7,0xd2,0xb8,0x34,0x57,0xe7,0xd4,0x58,0x69,0x7,0xd7,0xc1,0x2c,0x6a,0xd3,0xc7,0x96,0xac,0xd0,0xb,0xf7,0xa0,0x16,0xd3,0xe1,0xff,0xf,0x96,0xd7,0xf8,0xfe,0x3f,0xd6,0xaf,0xfc,0xfe,0x7c,0xea,0xaf,0xff,0x6d,0xff,0x6a,0xaf,0xff,0xef,0xff,0x6a,0xaf,0x7,0xff,0xe7,0xea,0xa7,0xaf,0x39,0xeb,0xca,0xaf,0xcf,0xff,0xc1,0xea,0xad,0xff,0xef,0xff,0xea,0xad,0xff,0x6d,0xff,0xea,0xae,0x7c,0xfe,0x7f,0xea,0xd7,0xf8,0xfe,0x3f,0xd6,0xd3,0xe1,0xff,0xf,0x96,0xd0,0xb,0xdf,0xa0,0x16,0x6a,0xd3,0xc7,0x96,0xac,0x69,0x7,0xd7,0xc1,0x2c,0x34,0x57,0xcf,0xd4,0x58,0x3a,0x17,0xde,0xd2,0xb8,0x9a,0x27,0xfe,0xc8,0xb2,0x8d,0x97,0xf9,0xd3,0x62,0xc6,0x43,0xff,0x84,0xc6,0xe3,0xb1,0xef,0x1b,0x8e,0xb1,0xce,0x0,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xcf,0xef,0xe7,0x1a,0xe3,0xbe,0xee,0xfb,0x8e,0xc6,0x7b,0xef,0xbc,0xc6,0x8d,0xef,0xef,0xef,0x62,0x9b,0xff,0xbb,0xff,0xb2,0x3b,0x7c,0x6c,0x7d,0xb8,0x37,0xb3,0xef,0x9b,0xd8,0x6f,0xff,0xef,0xff,0xec,0x6d,0xef,0xef,0xef,0x6c,0xdf,0xb7,0xef,0xdb,0xf6,0xdb,0xbf,0xff,0xbb,0xb6,0xdf,0x7c,0x3f,0xfd,0xf6,0xb7,0x7c,0x3c,0x3d,0xda,0xbf,0x79,0x38,0x1d,0xfa,0xbe,0xf9,0x39,0x9e,0xfa,0xbe,0xf3,0x3f,0x9e,0xfa,0xa1,0x13,0x3f,0x11,0xa,0xbe,0xf0,0x3e,0x3e,0xfa,0xbe,0xf0,0x3c,0x7e,0xfa,0xbf,0x7f,0x38,0xfd,0xfa,0xb7,0x7f,0x38,0x1d,0xda,0xdf,0x7f,0xf8,0x1d,0xf6,0xdb,0xbb,0xff,0xfb,0xb6,0xdf,0xb7,0xef,0xdb,0xf6,0x6d,0xef,0xef,0xef,0x6c,0x6f,0xff,0xef,0xff,0xec,0x37,0xb3,0xef,0x9b,0xd8,0x3b,0x7c,0x6c,0x7d,0xb8,0x9b,0xff,0xbb,0xff,0xb2,0x8d,0xef,0xef,0xef,0x62,0xc6,0x7b,0xef,0xbc,0xc6,0xe3,0xbe,0xee,0xfb,0x8e,0xb1,0xcf,0xef,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe},
	{0xff,0xf,0xff,0xe1,0xfe,0x8c,0x3e,0x0,0xf8,0x62,0x98,0xf1,0xff,0x1e,0x32,0xb1,0xcf,0xff,0xe7,0x1a,0xe3,0xbf,0x1,0xfb,0x8e,0xc6,0x78,0x0,0x3c,0xc6,0x8d,0xe0,0x0,0xf,0x62,0x1b,0xc0,0x0,0x7,0xb2,0x3b,0x7,0xff,0xc1,0xb8,0x37,0x1f,0xff,0xf1,0xd8,0x6e,0x7f,0xff,0xfc,0xec,0x6c,0x87,0xff,0xc2,0x6c,0xdd,0x71,0xff,0x7d,0x76,0xda,0x88,0x2,0xe2,0xb6,0xda,0x88,0x81,0x62,0xb6,0xb9,0x69,0x42,0xed,0x3a,0xb0,0x98,0x81,0xf2,0x1a,0xb0,0x6c,0x2,0xec,0x1a,0xb0,0x14,0x5,0xd0,0x1a,0xb0,0xa,0x3,0xa0,0x1a,0xb0,0x1a,0x5,0xb0,0x1a,0xb0,0x25,0xb,0x48,0x1a,0xb0,0x18,0x86,0x30,0x1a,0xb8,0x0,0x4c,0x0,0x3a,0xd8,0x0,0x28,0x0,0x36,0xd8,0x0,0x28,0x0,0x36,0xdc,0x0,0x28,0x0,0x76,0x6c,0x0,0x28,0x0,0x6c,0x6e,0x0,0x44,0x0,0xec,0x37,0x0,0x82,0x1,0xd8,0x3b,0x1,0xff,0x1,0xb8,0x9b,0xc1,0x83,0x7,0xb2,0x8d,0xe3,0xff,0x8f,0x62,0xc6,0x78,0x0,0x3c,0xc6,0xe3,0xbf,0x1,0xfb,0x8e,0xb1,0xcf,0xff,0xe7,0x1a,0x98,0xf1,0xff,0x1e,0x32,0x8c,0x3e,0x0,0xf8,0x62,0xff,0xf,0xff,0xe1,0xfe}};

const unsigned char BandeauStatistiques[]={0x0,0x80,0x0,0x0,0x0,0x20,0x0,0x0,0x0,0x20,0x0,0x0,0x0,0x0,0x8,0x0,0x18,0x0,0x0,0x0,0x0,0x27,0xbe,0x73,0xe7,0xa0,0x0,0x0,0x0,0x0,0x0,0xc0,0x18,0x86,0xae,0xa4,0xee,0x28,0xa2,0x8a,0x28,0xa3,0x33,0x9b,0xb1,0x3b,0x89,0xe0,0x18,0x8,0xa4,0xaa,0xa4,0x2b,0x36,0xab,0x6b,0x22,0xaa,0x22,0x2a,0xa9,0x3,0xf0,0x18,0x84,0xa4,0xae,0xa4,0x28,0x94,0x89,0x48,0xa3,0x33,0x23,0x2b,0xa9,0x8,0xc0,0x7e,0x2,0xa4,0xaa,0xa4,0x26,0x94,0xa9,0x46,0xa2,0x2a,0x22,0x2a,0xa9,0x0,0xc0,0x3c,0x8c,0x4e,0x4a,0xa4,0x28,0x94,0xa9,0x48,0xa2,0x2b,0x9b,0xb2,0xa9,0x8,0xc0,0x18,0x0,0x0,0x0,0x0,0x2f,0x1c,0xd9,0xcf,0x20,0x0,0x0,0x0,0x0,0x0,0xc0,0x0,0x80,0x0,0x0,0x0,0x20,0x0,0x0,0x0,0x20,0x0,0x0,0x0,0x0,0x8,0x0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xf8};
const unsigned char *TexteStatistiques[]={"Parties ------------","Temps de jeu total - 00:00:00","Best time victoire - 00:00:00","Succes sur 30 ------","Nombre de 2 --------","Nombre de 4 --------","Nombre de 8 --------","Nombre de 16 -------","Nombre de 32 -------","Nombre de 64 -------","Nombre de 128 ------","Nombre de 256 ------","Nombre de 512 ------","Nombre de 1024 -----","Nombre de 2048 -----","Nombre de 4096 -----","Nombre de 8192 -----"};
unsigned char *NombreStatistiques[10];

const unsigned char ImCredits[]={
	0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xc0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x3,0xcf,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xf3,0xcf,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xf8,0xf3,0xc9,0xe7,0xff,0xff,0xff,0xff,0xff,0xf3,0xf3,0xf3,0x1,0x80,0xf8,0x73,0xfc,0xf3,0xc9,0xe7,0xff,0xff,0xff,0xff,0xff,0xf3,0xf3,0xf3,0x3f,0x9e,0x73,0x33,0xfe,0x73,0xc9,0xe7,0xff,0xff,0xff,0xff,0xff,0xf3,0xf1,0xe3,0x3f,0x9e,0x67,0xb3,0xff,0xf3,0xc9,0xe6,0xf,0xf0,0x61,0x87,0x7,0x83,0xf1,0xe3,0x3f,0x9e,0x67,0xf3,0xf8,0x73,
	0xc9,0xe6,0x67,0xe6,0x63,0x33,0x33,0x33,0xf0,0xc3,0x3,0x9e,0x67,0xf3,0xf3,0x33,0xc9,0xe6,0x67,0xe6,0x67,0xc3,0x33,0x33,0xf0,0xc3,0x3f,0x80,0xe7,0xf3,0xfc,0x33,0xc9,0xe6,0x67,0xe6,0x67,0x93,0x33,0x33,0xf2,0x13,0x3f,0x9e,0x67,0xf3,0xf9,0x33,0xc9,0xe6,0x67,0xe6,0x67,0x33,0x33,0x33,0xf2,0x13,0x3f,0x9e,0x67,0xb3,0xf3,0x33,0xcc,0xce,0x67,0xe6,0x67,0x33,0x33,0x33,0xf3,0x33,0x3f,0x9e,0x73,0x33,0xf3,0x33,0xce,0x1e,0x67,0xf0,0x67,0x83,0x33,0x83,0xf3,0x33,0x1,0x9f,0x38,0x73,0xf8,0x33,0xc7,0xff,0xff,0xfe,0x7f,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xe3,0xe0,0x0,0x0,0x26,0x40,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x7,
	0xf0,0x0,0x0,0x10,0x80,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0xf,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xfb,0xc6,0xff,0xff,0xeb,0xff,0xff,0xf3,0x9f,0xff,0xfd,0xff,0xff,0xfd,0x5f,0xdf,0xf9,0xdb,0xff,0xff,0x6b,0xff,0xff,0xf3,0x9f,0xff,0xfd,0xff,0xff,0xfd,0xdf,0x9f,0xa0,0xda,0xd9,0x33,0x2b,0x8e,0x6a,0x75,0x59,0x9c,0xe4,0xcc,0xc3,0xbd,0x47,0x5,0xa0,0xc6,0xab,0x6d,0x6b,0xb5,0xaa,0xf5,0x56,0xab,0x5d,0x5b,0x55,0x5d,0x5b,0x5,0xf9,0xde,0xbb,0x6d,0x6b,0xb5,0xaa,0xf6,0xd6,0xab,0x5d,0x5b,0x55,0x7d,0x5b,0x9f,0xfb,0xde,0xcb,0x73,0xab,0x8e,0x72,0xf6,0xd9,0xac,0xe5,0x5c,0xd5,0x95,0x47,0xdf,
	0xff,0xff,0xff,0xff,0xff,0xbf,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xbf,0xff,0xe0,0x0,0x0,0x0,0x0,0x0,0x0,0x1,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xfd,0xef,0xff,0x7f,0xf7,0xff,0xef,0xff,0xff,0xf9,0xcf,0xff,0xff,0xfa,0xbf,0xbf,0xfc,0xef,0xff,0x7f,0xff,0xff,0xff,0xff,0xff,0xf9,0xcf,0xff,0xff,0xfb,0xbf,0x3f,0xa8,0x6f,0x63,0x3b,0x35,0x4e,0x69,0xc7,0x35,0x3a,0xad,0x87,0x32,0xba,0x8e,0x15,0xa8,0x6e,0xad,0x55,0x56,0xd5,0xab,0xda,0xd5,0x7a,0xaa,0xaa,0xd6,0xba,0xb6,0x15,0xfc,0xee,0xed,0x57,0x56,0xd5,0xab,0xda,0xd5,0x7b,0x6b,0xaa,0xd6,0xba,0xb7,0x3f,
	0xfd,0xe3,0x23,0x59,0x55,0x56,0x6b,0xc7,0x39,0x7b,0x6c,0xab,0x37,0x6a,0x8f,0xbf,0xff,0xff,0xef,0xff,0xff,0xff,0xff,0xdf,0xff,0xff,0xff,0xff,0xff,0x7f,0xff,0xff,0xff,0xff,0xef,0xff,0xff,0xff,0xff,0xdf,0xff,0xf0,0x0,0x0,0x2,0xc0,0x3,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xf7,0xbf,0xfd,0xff,0xdf,0xff,0xbf,0xff,0xff,0xe0,0xff,0xfb,0xaf,0xef,0xff,0xff,0xf3,0xbf,0xfd,0xff,0xff,0xff,0xff,0xff,0xff,0xfb,0xff,0x7b,0xef,0xcf,0xff,0xaa,0xa1,0xbd,0x8c,0xec,0xd5,0x39,0xa7,0x1c,0xd4,0xfb,0xb5,0x3b,0xa3,0x85,0x55,0xaa,0xa1,0xba,0xb5,0x55,0x5b,0x56,0xaf,0x6b,0x55,0xfb,0x5b,0x7b,0xad,0x85,0x55,
	0xff,0xf3,0xbb,0xb5,0x5d,0x5b,0x56,0xaf,0x6b,0x55,0xfb,0x7b,0x7b,0xad,0xcf,0xff,0xff,0xf7,0x8c,0x8d,0x65,0x55,0x59,0xaf,0x1c,0xe5,0xfb,0x95,0xa8,0xa3,0xef,0xff,0xff,0xff,0xff,0xbf,0xff,0xff,0xff,0xff,0x7f,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xbf,0xff,0xff,0xff,0xff,0x7f,0xff,0xc0,0x0,0x0,0x0,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xfb,0xc3,0xfe,0xff,0xff,0xff,0xff,0xff,0xfe,0xf,0xff,0x7d,0x5f,0xdf,0xff,0xff,0xf9,0xdd,0xfe,0xff,0xbf,0xff,0xff,0xff,0xff,0xbf,0xff,0x7d,0xdf,0x9f,0xff,0xaa,0xa0,0xdd,0x32,0xbc,0x99,0x90,0xf1,0xcd,0x4f,0xb3,0x59,0x3d,0x47,0x5,0x55,
	0xaa,0xa0,0xdd,0xd6,0x7b,0xb6,0xb5,0x76,0xb5,0x5f,0xad,0x57,0x5d,0x5b,0x5,0x55,0xff,0xf9,0xdd,0x56,0xbe,0xb6,0xb5,0x76,0xb5,0x5f,0xad,0x57,0x5d,0x5b,0x9f,0xff,0xff,0xfb,0xc3,0x96,0xb9,0xd9,0xb5,0x71,0xce,0x5f,0xb3,0x99,0x55,0x47,0xdf,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xf7,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xf7,0xff,0xfc,0x0,0x0,0x0,0x1,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xfb,0xff,0xff,0xbf,0xff,0xff,0xff,0xff,0xff,0x87,0xef,0xff,0xff,0xff,0xff,0xff,0xf7,0x8d,0xff,0xdf,0xfc,0x7f,0xef,0xc0,0x1,
	0xbd,0xef,0xff,0xff,0xff,0xff,0xff,0x7f,0xb5,0xff,0xf7,0xfb,0xbf,0xff,0xdd,0x5d,0x8c,0xe9,0xf3,0x30,0xc3,0x53,0x35,0x37,0xb5,0x33,0xb3,0x7b,0xe7,0x2c,0xd1,0x51,0xbd,0xee,0xee,0xd5,0x55,0x55,0xd5,0x6b,0x8d,0xd5,0x56,0xbb,0xfa,0xeb,0x58,0x99,0xbd,0xea,0xee,0xd5,0x55,0x55,0x55,0x6f,0xbd,0x55,0x76,0xfb,0xab,0xab,0x51,0x51,0x86,0xec,0xf3,0x35,0x55,0x95,0x99,0xb3,0xbd,0x95,0x9b,0x3c,0x72,0x6c,0xdd,0x5d,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xc0,0x1,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff,0xff};

srand(time_getTicks());

Txt_Init(FONT_MINISD | FONT_ARCADIUM);

while(1){

	if(!memory_exists(FILEPATH)){		//Cre un fichier lors de la premire utilisation du jeu
		memory_createfile(FILEPATH,126);
		Save(Record,Score,TempsPartie,Grille,MedaillesObtenues,Statistiques);
		}

	Read(&Record,&Score,&TempsPartie,Grille,MedaillesObtenues,Statistiques);	//Extrait les informations du fichier

	ML_clear_vram();		//Effaage de l'cran

		//Dessin de l'interface du menu
	ML_rectangle(0,0,64,62,1,1,0);		//Rectangle de gauche
	ML_rectangle(65,0,127,62,1,1,0);	//Rectangle de droite
	ML_horizontal_line(63,0,127,1);	//Ligne du bas de l'cran
	ML_bmp_16_or(P2[2],66,1);		//2
	ML_bmp_16_or(Im0,81,1);		//0
	ML_bmp_16_or(P2[3],96,1);		//4
	ML_bmp_16_or(P2[4],111,1);		//8
	ML_bmp_or(DELUX,67,17,59,12);	//DELUX
	ML_bmp_or(ImRecord,66,30,61,7);	//Record
	ML_bmp_or(Kirafi,67,48,59,13);	//Kirafi

		//Dessin du record
	AffTxt=Record;
	if(AffTxt==0)ML_bmp_or(Chiffres[0],93,39,7,7);		//Si Record=0 dessine un 0
	for(Z=93+3*(int)(log10(AffTxt));AffTxt;Z-=6){
		ML_bmp_or(Chiffres[AffTxt%10],Z,39,7,7);		//Dessin de chaque chiffres du record
		AffTxt/=10;
    		}
	X=1;		//"Continuer" est selectionn par dfaut
	X2=X;

	while(1){
		for(Z=4;Z<55;Z+=10)ML_bmp_or(TexteMenu[((Z-4)/10)*2],13,Z,39,5);	//Dessin du texte du menu
		ML_rectangle(13,4+X*10,51,8+X*10,0,0,0);						//Effaage du texte selectionn
		ML_bmp_or(TexteMenu[X*2+1],4,3+X*10,57,7);					//Dessin du texte selectionn
		Sleep(2);									//Truc anti-bug d'affichage...
		ML_display_vram();							//Affichage du menu
		while(key_down(28) || key_down(37) || key_down(31));		//Attend que les touche haut/bas/EXE soient relaches
		X2=X;
		while(X2==X){
			if(key_down(28))X--;
			if(key_down(37))X++;
			if(key_down(31) || key_down(47))break;	//EXE ou EXIT
			}
		if(X<0)X=5;
		if(X>5)X=0;
		ML_rectangle(1,1,63,61,0,0,0);		//Effaage du texte
		if(key_down(31) || key_down(47))break;		//EXE ou EXIT pour valider/quitter
		}

	while(key_down(31));	//Attend que EXE soit relach
	if(key_down(47))X=5;	//EXIT pour quitter
	ChoixMode=X;		//Choix du mode du menu

	if(ChoixMode<2){		//Fonction du jeu

			//Choix du succ  pouvoir raliser cette session de partie
		Txt_Text("Quel succe",3,3,TXT_ARCADIUM,TXT_OR);
		Txt_Text("veux - tu",7,10,TXT_ARCADIUM,TXT_OR);
		Txt_Text("realiser ?",3,17,TXT_ARCADIUM,TXT_OR);
		X=0;
		while(1){
			for(Z=0;Z<4;Z++)ML_bmp_or(ImTexteSucces[Z+4],2,27+Z*9,61,7);		//Dessin des succs  selectionner
			ML_rectangle(1,26+X*9,63,34+X*9,0,0,2);							//Dessin du succ selectionn
			ML_display_vram();									//Affichage du menu de selection du succ
			while(key_down(28) || key_down(37) || key_down(31));		//Attend que les touche haut/bas/EXE soient relaches
			X2=X;
			while(X2==X){
				if(key_down(28))X--;
				if(key_down(37))X++;
				if(key_down(31))break;
				}
			if(X<0)X=3;
			if(X>3)X=0;
			ML_rectangle(1,26,63,61,0,0,0);	//Effaage du texte des succs
			if(key_down(31))break;			//EXE pour valider
			}
		ChoixSucceOrganisation=X;
		while(key_down(31));		//Attend que EXE soit relach

		if(ChoixMode==0){
				//Si nouvelle partie, teste si l'ancien score est plus lev que le record
			if(Score>Record){				//Nouveau record 
				Record=Score;			//Le record prend la valeur du score
				Save(Record,Score,TempsPartie,Grille,MedaillesObtenues,Statistiques);	//Stocke les donnes dans un fichier
				}
			Score=0;	//Rinitialisation du score  zro
			}

		while(1){	//Jeu

			ML_clear_vram();				//Effaage de l'cran

				//Dessin de l'interface du jeu
			ML_rectangle(0,0,62,62,1,1,0);		//Rectangle de gauche
			ML_rectangle(63,0,127,62,1,1,0);	//Rectangle de Droite
			ML_horizontal_line(63,0,127,1);	//Ligne du bas de l'cran
			ML_rectangle(64,20,126,21,1,1,0);	//Ligne qui spare le score et le record
			ML_rectangle(64,41,126,42,1,1,0);	//Ligne qui spare le record du cadre spcial
			ML_bmp_or(ImScore1,66,2,59,7);	//Score
			ML_bmp_or(ImRecord,65,23,61,7);	//Record
			ML_bmp_or(ImTime,83,44,25,7);	//Time

				//Dessin du score
			AffTxt=Score;
			if(AffTxt==0)ML_bmp_or(Chiffres[0],92,11,7,7);		//Si Record=0 dessine un 0
			for(Z=92+3*(int)(log10(AffTxt));AffTxt;Z-=6){
				ML_bmp_or(Chiffres[AffTxt%10],Z,11,7,7);		//Dessin de chaque chiffres du score
				AffTxt/=10;
    				}

				//Dessin du record
			AffTxt=Record;
			if(AffTxt==0)ML_bmp_or(Chiffres[0],92,32,7,7);		//Si Score=0 dessine un 0
			for(Z=92+3*(int)(log10(AffTxt));AffTxt;Z-=6){
				ML_bmp_or(Chiffres[AffTxt%10],Z,32,7,7);		//Dessin de chaque chiffres du record
				AffTxt/=10;
    				}

				//Teste si nouvelle partie
			if(Score==0){
				TempsPartie=0;	//Initialisation du temps  00:00:00

				Statistiques[0]++;		//Sauvegarde du nombre de partie cr

					//Initialisation des donnes de la grille
				for(X=0;X<4;X++)for(Y=0;Y<4;Y++)Grille[Y][X]=0;					//Inisialisation de la grille
				for(X=0;X<4;X++)for(Y=0;Y<4;Y++)ML_bmp_16_or(P2[1],X*15+1,Y*15+1);	//Dessin des cases vides de la grille
				ML_display_vram();										//Affichage de la grille vide

					//Cration alatoire des coordonnes des premiers chiffres
				for(Z=0;Z<2;Z++){
					while(Grille[Y][X]){
						X=rand()%4;
						Y=rand()%4;
						}
					Apparition=rand()%10;			// 90%=2 ou 10%=4
					if(Apparition)Grille[Y][X]=1;
					else Grille[Y][X]=2;
					ML_bmp_16_and(P2[0],X*15+1,Y*15+1);	//Dessin des chiffres d'apparition
					}

				ML_display_vram();	//Affichage de l'cran de jeu

				Sleep(150);		//Temps de latence pour l'animmation des premiers nombres
				}		//Fin de le cration de nouvelle partie

			ML_rectangle(0,0,62,62,1,1,0);											//Effaage de la grille
			for(X=0;X<4;X++)for(Y=0;Y<4;Y++)ML_bmp_16_or(P2[Grille[Y][X]+1],X*15+1,Y*15+1);	//Dessin la grille

			ML_display_vram();	//Affichage de la grille

			if(Score>=20084)Gagne=2;	//Test si le joueur a dj obtenu un 2048 (en fonction de son score)
			else Gagne=0;

				//Initialisation variable de test des succs
				Chance=0;
				for(Z=0;Z<8;Z++)TestFusion1[Z]=0;
				for(Z=0;Z<8;Z++)TestFusion2[Z]=0;
				NbrFusion=0;
				NbrCombo=0;
				NbrSuite=0;
				TestSuite=0;
				NbrDesordonne=0;
				TestArtistique=0;
				TempsReference=RTC_getTicks();
				while(Secondes!=TempsPartie%100){
					TempsActuel=RTC_getTicks();
					Secondes=(TempsActuel-TempsReference);
					}
				Minutes=(TempsPartie%10000)/100;
				Heures=TempsPartie/10000;
				TempsReference=TempsActuel;
				TempsSession=0;

				ML_bmp_or(ImTempsNul,71,53,47,7);		//Temps  00 : 00 : 00
				ML_rectangle(107,53,117,59,0,0,0);			//Effaage des secondes
				ML_bmp_or(Chiffres[Secondes%10],112,53,7,7);	//Dessin des units des secondes
				ML_bmp_or(Chiffres[Secondes/10],106,53,7,7);	//Dessin des dixaines des secondes
				ML_rectangle(89,53,99,59,0,0,0);			//Effaage des minutes
				ML_bmp_or(Chiffres[Minutes%10],94,53,7,7);	//Dessin des units des minutes
				ML_bmp_or(Chiffres[Minutes/10],88,53,7,7);	//Dessin des dixaines des minutes
				ML_rectangle(71,53,81,59,0,0,0);			//Effaage des heures
				ML_bmp_or(Chiffres[Heures%10],76,53,7,7);	//Dessin des units des heures
				ML_bmp_or(Chiffres[Heures/10],70,53,7,7);	//Dessin des dixaines des heures

			while(1){	//Moteur du jeu

				while(key_down(27) || key_down(38) || key_down(28) || key_down(37)){	//Attend le relachement des touches directionnelles
						//Incrmentation du score
					TempsActuel=RTC_getTicks();
					if((TempsActuel-TempsReference)/128){
						TempsReference=RTC_getTicks();
						Secondes++;				//Secondes
						if(Secondes>=60){
							Minutes++;			//Minutes
							if(Minutes>=60){
								Heures++;		//Heures
								ML_rectangle(71,53,81,59,0,0,0);			//Effaage des heures
								ML_bmp_or(Chiffres[Heures%10],76,53,7,7);	//Dessin des units des heures
								ML_bmp_or(Chiffres[Heures/10],70,53,7,7);	//Dessin des dixaines des heures
								Minutes=0;							//Rinitialisation des minutes
								}
							ML_rectangle(89,53,99,59,0,0,0);			//Effaage des minutes
							ML_bmp_or(Chiffres[Minutes%10],94,53,7,7);	//Dessin des units des minutes
							ML_bmp_or(Chiffres[Minutes/10],88,53,7,7);	//Dessin des dixaines des minutes
							Secondes=0;						//Rinitialisation des secondes
							}
						ML_rectangle(107,53,117,59,0,0,0);			//Effaage des secondes
						ML_bmp_or(Chiffres[Secondes%10],112,53,7,7);	//Dessin des units des secondes
						ML_bmp_or(Chiffres[Secondes/10],106,53,7,7);	//Dessin des dixaines des secondes

						ML_display_vram();	//Affichage du temps
						}
					 }

					//Le joueur choisie une direction
				Direction=0;		//Rinitialisation de la direction
				while(Direction==0)
				{	//Le joueur choisi une direction (les chiffres correspondent  leur flche sur le clavier)
					
					do 
					{	// Tant qu'un point n'a pas ete presse, ou une touche du replay
						TL_getTouchXY(&point1);
						if(key_down(27))Direction=3;
						if(key_down(38))Direction=1;
						if(key_down(28))Direction=8;
						if(key_down(37))Direction=5;
						if(key_down(48))Direction=10;		//Touche [MENU] pour retourner au menu
						if(key_down(68)){				//Touche [OPTN] pour passer l'animation des chiffres on/off
							if(ChoixAnimation)ChoixAnimation=0;
							else ChoixAnimation=1;
							while(key_down(68));
							}
							//Incrmentation du score
						TempsActuel=RTC_getTicks();
						if((TempsActuel-TempsReference)/128){
							TempsReference=RTC_getTicks();
							Secondes++;		//Secondes
							}
						if(Secondes>=60){
							Minutes++;			//Minutes
							if(Minutes>=60){
								Heures++;		//Heures
								ML_rectangle(71,53,81,59,0,0,0);			//Effaage des heures
								ML_bmp_or(Chiffres[Heures%10],76,53,7,7);	//Dessin des units des heures
								ML_bmp_or(Chiffres[Heures/10],70,53,7,7);	//Dessin des dixaines des heures
								Minutes=0;							//Rinitialisation des minutes
								}
							ML_rectangle(89,53,99,59,0,0,0);			//Effaage des minutes
							ML_bmp_or(Chiffres[Minutes%10],94,53,7,7);	//Dessin des units des minutes
							ML_bmp_or(Chiffres[Minutes/10],88,53,7,7);	//Dessin des dixaines des minutes
							Secondes=0;						//Rinitialisation des secondes
							}
						ML_rectangle(107,53,117,59,0,0,0);			//Effaage des secondes
						ML_bmp_or(Chiffres[Secondes%10],112,53,7,7);	//Dessin des units des secondes
						ML_bmp_or(Chiffres[Secondes/10],106,53,7,7);	//Dessin des dixaines des secondes

						ML_display_vram();	//Affichage du temps

					}while(point1.x < 0 && !Direction);

					if(Direction) break; 	//Si on a deja appuye sur une touchedu replay, inutile de continuer

					i = 10; 	//Sert a savoir si on  bien retire le doigt ou si c'est juste temporaire

					do
					{
						if(point2.x >= 0) // si on appuie sur un point, on met a jour le 3eme point (voir note /**/ ci-dessous) et le "timer"
						{
							point3.x = point2.x;
							point3.y = point2.y;
							i = 10;
						}
						else
						{
							i--;
						}

						TL_getTouchXY(&point2);
					}while(i); 	//Tant qu'on a pas relache de touche pendant 30 frames, on continue de mettre a jour

					/* le fait d'utiliser ci-dessus un troisieme point permet de garder en memoire la valeur du dernier point sur lequel on appuie, sinon on aurait tout le temps {-1, -1} */

					i = point3.x - point1.x;
					j = point3.y - point1.y;

					if(ABS(i) > ABS(j)) 	//Si le deplacement le plus important est celui des x
					{
						Direction = (i<0) ? 1 : 3; 		//On donne la valeur du deplacement en fonction des deplacements effectues
					}
					else 		//Idem pour les y
					{
						Direction = (j<0) ? 8 : 5; 		//Ces conditions condenses reviennent a faire "if(j<0) Direction=8; else Direction=5;"
					}
				}	//Fin de la boucle de choix d'une direction

					//Condition pour revenir au menu
				if(Direction==10){	
					TempsSession=Secondes+Minutes*100+Heures*10000;
					Statistiques[1]+=TempsSession-TempsPartie;
					TempsPartie=TempsSession;
					if(Statistiques[1]%100>59)Statistiques[1]+=40;
					if(Statistiques[1]%10000/100>59)Statistiques[1]+=4000;
					Save(Record,Score,TempsPartie,Grille,MedaillesObtenues,Statistiques);	//Sauvegarde de la partie
					break;	//Retour au menu
					}

					//Condition qui dplace les nombres
				if(Direction!=10){
					TestCoups=0;
					for(Z=0;Z<4;Z++){	//Rinitialisation les collisions  zro
						Boleens1[Z]=0;
						Boleens2[Z]=0;
						}
					for(NbrDeplacement=0;NbrDeplacement<3;NbrDeplacement++){		//Le nombre de dplacement
						for(Z=0;Z<4;Z++)Boleens1[Z]=Boleens2[Z];
						for(I=1;I<4;I++){		//Parcourt la grille
							for(J=0;J<4;J++){			//Parcourt la grille
								E=Boleens1[J]+I;
								if(E<4){
									if(Direction==1)X=E;		//Coordonnes de la case  dplacer
									if(Direction==3)X=3-E;
									if(Direction<4)Y=J;
									if(Direction==8)Y=E;
									if(Direction==5)Y=3-E;
									if(Direction>4)X=J;
									X2=X;
									Y2=Y;
									if(Direction==1)X2=X-1;		//Coordonnes de la case vis
									if(Direction==3)X2=X+1;
									if(Direction==8)Y2=Y-1;
									if(Direction==5)Y2=Y+1;
									Case1=Grille[Y][X];		//Case  dplacer
									Case2=Grille[Y2][X2];		//Case vis
									if(Case1){				//Si il y a un nombre dans la case  dplacer
										if(!Case2){			//Si il n'y a rien dans la case vis, on y dplace le nombre K
											Grille[Y2][X2]=Case1;
											Grille[Y][X]=0;
											if(ChoixAnimation){
												ML_bmp_16_or(P2[1],X*15+1,Y*15+1);		//Affichage du mouvement des nombres
												ML_bmp_16_and(P2[Grille[Y2][X2]+1],X2*15+1,Y2*15+1);
												}
											TestCoups=1;		//Un coup viens d'tre jou
											}
										if(Case2==Case1){		//Si les 2 nombres sont les mme, a fusionne
											Boleens2[J]=E;		//Paramtres anti-double-fusion
											Case2++;
											if(Case2==11 && !Gagne)Gagne=1;		//Le 2048 apparait !
											Grille[Y2][X2]=Case2;
											Grille[Y][X]=0;
											if(ChoixAnimation){
												ML_bmp_16_or(P2[1],X*15+1,Y*15+1);		//Affichage du mouvement des nombres
												ML_bmp_16_or(P2[1],X2*15+1,Y2*15+1);
												ML_bmp_16_and(P2[0],X2*15+1,Y2*15+1);
												ML_bmp_16_and(P2[Grille[Y2][X2]+1],X2*15+1,Y2*15+1);
												}
											TestCoups=1;
											Score+=pow(2,Case2);			//Augmentation du score
											ML_bmp_or(ImScore2,66,2,59,7);	//Dessin de l'annimation du score

											for(Z=3;Z<6;Z++)if(Case2==Z+7 && !MedaillesObtenues[Z])MedaillesObtenues[Z]=2;		//Test si les succs de Fusion sont ralises

											Statistiques[Case2+3]++;		//Sauvegarde du nombre cr dans les statistiques
											TestFusion1[NbrFusion]=Case2;	//Enregistrement des nombres de fusion
											NbrFusion++;				//Enregistrement du nombre de fusion ralis pour ce coups
											}
										}
									}
								}
							if(ChoixAnimation){
								ML_display_vram();	//Affichage du dplacement des nombre
								Sleep(20);
								}
							}
						}	//Fin du dplacement des cases

					TestCase=1;
					if(TestCoups){	//Si un coups viens d'tre jou
						Sleep(2);	//Truc anti-bug d'affichage...

						ML_rectangle(0,0,62,62,1,1,0);											//Effaage de la grille
						for(X=0;X<4;X++)for(Y=0;Y<4;Y++)ML_bmp_16_or(P2[Grille[Y][X]+1],X*15+1,Y*15+1);	//Dessin de la grille

						ML_rectangle(64,10,126,18,1,0,0);				//Effaage du score
						AffTxt=Score;
						if(AffTxt==0)ML_bmp_or(Chiffres[0],92,11,7,7);		//Si Score=0, Dessine un 0
						for(Z=92+3*(int)(log10(AffTxt));AffTxt;Z-=6){
							ML_bmp_or(Chiffres[AffTxt%10],Z,11,7,7);		//Dessin de chaque chiffre du score
							AffTxt/=10;
    							}

						if(Gagne==1){
							if(!MedaillesObtenues[28] && Secondes+Minutes*100+Heures*10000==642)MedaillesObtenues[28]=2;			//Test du succ 42
							ML_rectangle(64,43,126,61,0,0,0);	//Effaage de la 3me zone d'criture
							ML_bmp_or(ImGagne,65,44,61,16);	//Dessin du message de victoire "Gagn"
							}
						ML_display_vram();	//Affichage du jeu

						if(Gagne==1){
							while(!key_down(31));	//Attend l'appuis de [EXE] pour continuer  jouer
							while(key_down(31));	//Attend que [EXE] soit relach
							Gagne=2;			//Change la valeur pour que le joueur ne gagne pas plusieurs fois
							ML_rectangle(64,43,126,61,0,0,0);	//Effaage de la 3me zone d'criture
							if(Secondes+Minutes*100+Heures*10000<Statistiques[2] || !Statistiques[2]){
								Statistiques[2]=Secondes+Minutes*100+Heures*10000;	//Meilleur temps victoire
								ML_bmp_or(TexteMenu[1],67,44,57,7);			//Dessin de "Nouveau"
								ML_bmp_or(ImTime,83,53,25,7);				//Dessin de "TIME"
								ML_display_vram();
								while(!key_down(31));			//Attend l'appuis de [EXE] pour continuer  jouer
								while(key_down(31));			//Attend que [EXE] soit relach
								ML_rectangle(64,43,126,61,0,0,0);	//Effaage de la 3me zone d'criture
								}
							ML_bmp_or(ImTime,83,44,25,7);			//Time
							ML_bmp_or(ImTempsNul,71,53,47,7);		//Temps  00 : 00 : 00
							ML_rectangle(107,53,117,59,0,0,0);			//Effaage des secondes
							ML_bmp_or(Chiffres[Secondes%10],112,53,7,7);	//Dessin des units des secondes
							ML_bmp_or(Chiffres[Secondes/10],106,53,7,7);	//Dessin des dixaines des secondes
							ML_rectangle(89,53,99,59,0,0,0);			//Effaage des minutes
							ML_bmp_or(Chiffres[Minutes%10],94,53,7,7);	//Dessin des units des minutes
							ML_bmp_or(Chiffres[Minutes/10],88,53,7,7);	//Dessin des dixaines des minutes
							ML_rectangle(71,53,81,59,0,0,0);			//Effaage des heures
							ML_bmp_or(Chiffres[Heures%10],76,53,7,7);	//Dessin des units des heures
							ML_bmp_or(Chiffres[Heures/10],70,53,7,7);	//Dessin des dixaines des heures
							}

						while(Grille[Y][X]){
							X=rand()%4;		//Cration alatoire des coordonnes du nouveau chiffre de la grille
							Y=rand()%4;
							}
						Apparition=rand()%10;		//90%=2 ou 10%= 4
						if(!Apparition){
							Grille[Y][X]=2;
							Chance++;
							}
						else {
							Grille[Y][X]=1;
							Chance=0;
							}
						Statistiques[Grille[Y][X]+3]++;			//Sauvegarde du nombre cr dans les statistiques
						ML_bmp_16_and(P2[0],X*15+1,Y*15+1);	//Dessin du nouveau chiffres
						ML_display_vram();				//Affichage du nouveau chiffre
						Sleep(100);						//Latence du  l'animation d'apparition du nouveau chiffre
						ML_bmp_16_or(P2[1],X*15+1,Y*15+1);
						ML_bmp_16_and(P2[Grille[Y][X]+1],X*15+1,Y*15+1);	//Dessin des chiffres alatoire
						ML_bmp_and(ImScore1,66,2,59,7);				//Dessin du score

						ML_display_vram();						//Affichage de la grille

						TestCase=0;	//Test si le joueur a perdu
						for(X=0;X<4;X++)for(Y=0;Y<4;Y++)if(!Grille[Y][X])TestCase++;		//Test si il reste des cases vides sur la grille
						if(!TestCase){		//Si il n'y a pas de case vide...
							for(X=0;X<4;X++)for(Y=0;Y<3;Y++)if(Grille[Y][X]==Grille[Y+1][X])TestCase++;	//Test si il y a 2 cases adjacentes ayant le mme nombre sur l'axe Y
							for(Y=0;Y<4;Y++)for(X=0;X<3;X++)if(Grille[Y][X]==Grille[Y][X+1])TestCase++;	//Test si il y a 2 cases adjacentes ayant le mme nombre sur l'axe X
							}

							//Test de validation des succs avec fusion
						if(NbrFusion){					//Si il y a au moins une fusion	
							NbrCombo++;
							if(TestFusion2[0]){
								for(Z2=0;Z2<NbrFusion;Z2++)for(Z=0;Z<8;Z++)if(TestFusion1[Z2]-1==TestFusion2[Z])TestSuite++;
								if(TestSuite){
									NbrSuite++;
									NbrDesordonne=1;
									}
								else {
									NbrDesordonne++;
									NbrSuite=1;
									}
								}
							if(!TestFusion2[0]){
								NbrSuite=1;
								NbrDesordonne=1;
								}
							for(Z=0;Z<NbrFusion;Z++)TestFusion2[Z]=TestFusion1[Z];
							}
						else {
							for(Z=0;Z<8;Z++)TestFusion2[Z]=0;		//Rinitialisation des variable qui valide les succs avec fusion si aucune fusion n'est ralis
							NbrCombo=0;
							NbrSuite=0;
							NbrDesordonne=0;
							}

							//Test de tout les succ
						for(Z=0;Z<30;Z++)if(MedaillesObtenues[Z]!=1){
							Z2=0;							//Boleen pour savoir si succ ralis

							if(Z==0 && Statistiques[1]+(Secondes+Minutes*100+Heures*10000-TempsPartie)>3000)Z2=1;	//Addiction 1
							if(Z==1 && Statistiques[1]+(Secondes+Minutes*100+Heures*10000-TempsPartie)>13000)Z2=1;	//Addiction 2
							if(Z==2 && Statistiques[1]+(Secondes+Minutes*100+Heures*10000-TempsPartie)>43000)Z2=1;	//Addiction 3

							if(Z>=3 && Z<=5 && MedaillesObtenues[Z]==2)Z2=1;	//Fusion

							if(Z==6 && Score>7000)Z2=1;	//Survie 1
							if(Z==7 && Score>42000)Z2=1;	//Survie 2
							if(Z==8 && Score>77000)Z2=1;	//Survie 3

							if(Z==9 && !TestCase && Score>300 && Score<=600)Z2=1;	//Kamikaze 1
							if(Z==10 && !TestCase && Score>150 && Score<=300)Z2=1;	//Kamikaze 2
							if(Z==11 && !TestCase && Score<=150)Z2=1;				//Kamikaze 3

							if(ChoixSucceOrganisation==0 && Z>=12 && Z<=14 && NbrCombo==5+(Z-12)*3)Z2=1;		//Combo

							if(ChoixSucceOrganisation==1 && Z>=15 && Z<=17 && NbrSuite==3+(Z-15)*3)Z2=1;		//Suite

							if(ChoixSucceOrganisation==2 && Z>=18 && Z<=20 && NbrDesordonne==3+(Z-18))Z2=1;	//Dsordonn

							if(ChoixSucceOrganisation==3 && Z>=21 && Z<=23 && NbrFusion==2+(Z-21)*2)Z2=1;		//Eliminiation

							if(Z>=24 && Z<=26){				//Teste Succ Artistiques
								TestArtistique=0;
								for(X=0;X<16;X++)if(Grille[X/4][X%4])TestArtistique+=pow(2,X);								//Analyse la grille pour les succs artistiques
								if(Z==24 && (TestArtistique==4095 || TestArtistique==30583 || TestArtistique==61166 || TestArtistique==65520))Z2=1;	//Artistique 1
								if(Z==25 && (TestArtistique==4991 || TestArtistique==36079 || TestArtistique==63281 || TestArtistique==65224))Z2=1;	//Artistique 2
								if(Z==26 && (TestArtistique==51 || TestArtistique==204 || TestArtistique==13056 || TestArtistique==52224))Z2=1;		//Artistique 3
								}

							if(Z==27 && Chance==2)Z2=1;				//Autre (chance)
							if(Z==28 && MedaillesObtenues[28]==2)Z2=1;		//Autre (42)
							if(Z==29){								//Autre (russir tout les succs)
								TestDernierSucce=0;
								for(i=0;i<29;i++)if(!MedaillesObtenues[i])TestDernierSucce++;
								if(!TestDernierSucce)Z2=2;
								}

							if(Z2){
								MedaillesObtenues[Z]=1;		//Dbloquage du succ
								Statistiques[3]++;		//Sauvegarde du nombre de succs russi
								AffTxt=0;
								Defilement=0;
								Ralentissement=0;
								while(!key_down(31)){			//Attend l'appuis de "EXE"
									ML_rectangle(64,43,126,61,0,0,0);	//Effaage de la 3me zone d'criture
									ML_rectangle(64,52,126,60,1,1,0);	//Cadre du texte du succ
									if(AffTxt>=0 && AffTxt<1000)ML_bmp_or(ImTexteSucces[Z/3],65,44,61,7);	//Dessin du succ obtenu
									if(AffTxt>=1000)ML_bmp_or(ImExe,87,44,17,7);						//Dessin de "EXE"

									if(strlen(TextesSucces[Z])>=15){
										strncpy(buffer,TextesSucces[Z]+Defilement,15);
										buffer[16]=0;
										Txt_Text(buffer,66,54,TXT_MINISD,TXT_OR);
										}
									else Txt_Text(TextesSucces[Z],66,54,TXT_MINISD,TXT_OR);

									AffTxt++;
									if(AffTxt==1500)AffTxt=0;
									if(!Defilement)Ralentissement++;
									if(!(AffTxt%50) && Ralentissement>500 && Defilement<strlen(TextesSucces[Z])-15)Defilement++;
									if(Defilement==strlen(TextesSucces[Z])-15)Ralentissement++;
									if(Ralentissement==1500){
										Ralentissement=0;
										Defilement=0;
										}

									ML_display_vram();				//Affichage du message de succ
									}
								while(key_down(31));			//Attend le relachement de "EXE"
								ML_rectangle(64,43,126,61,0,0,0);			//Effaage du succ
								ML_bmp_or(ImTime,83,44,25,7);			//Dessin de Time
								ML_bmp_or(ImTempsNul,71,53,47,7);		//Dessin du temps  00 : 00 : 00
								ML_rectangle(107,53,117,59,0,0,0);			//Effaage des secondes
								ML_bmp_or(Chiffres[Secondes%10],112,53,7,7);	//Dessin des units des secondes
								ML_bmp_or(Chiffres[Secondes/10],106,53,7,7);	//Dessin des dixaines des secondes
								ML_rectangle(89,53,99,59,0,0,0);			//Effaage des minutes
								ML_bmp_or(Chiffres[Minutes%10],94,53,7,7);	//Dessin des units des minutes
								ML_bmp_or(Chiffres[Minutes/10],88,53,7,7);	//Dessin des dixaines des minutes
								ML_rectangle(71,53,81,59,0,0,0);			//Effaage des heures
								ML_bmp_or(Chiffres[Heures%10],76,53,7,7);	//Dessin des units des heures
								ML_bmp_or(Chiffres[Heures/10],70,53,7,7);	//Dessin des dixaines des heures
								}
							}		//Fin de la fonction de teste des succs

						for(Z=0;Z<8;Z++)TestFusion1[Z]=0;		//Rinitialisation des variables qui enregistrent donnes relatives aux succs qui ont t cr au dernier coups
						NbrFusion=0;
						TestSuite=0;

						ML_display_vram();	//Affichage du jeu

						}	//Fin des fonctions de test d'aprs dplacement

					}	//Fin des fonctions effectues lors d'un dplacement

					if(!TestCase)break;	//Si aucun coups ne peut tre jou au prochain tour, on sort de la boucle du moteur du jeu et le joueur a perdu

				}	//Fin de la boucle du moteur du jeu

				if(Direction==10)break;		//Condition pour revenir au menu

				if(Score>Record){					//Teste si nouveau record
					Record=Score;					//Le score s'enregistre dans le record
					ML_rectangle(67,2,123,9,1,0,0);		//Effaage du "Score" 
					ML_bmp_or(TexteMenu[1],67,2,57,7);	//Dessin de "Nouveau"
					}
				
				Score=0;					//Rinitialisation du score
				TempsSession=Secondes+Minutes*100+Heures*10000;
				Statistiques[1]+=TempsSession-TempsPartie;
				TempsPartie=TempsSession;
				Save(Record,Score,TempsPartie,Grille,MedaillesObtenues,Statistiques);		//Stocke les donnes dans le fichier de sauvegarde de partie
				ML_rectangle(64,43,126,61,0,0,0);	//Effaage de la 3me zone d'criture
				ML_bmp_or(ImPerdu,65,44,63,7);	//Dessin de "Perdu"
				ML_bmp_or(ImExe,87,53,17,7);		//Dessin de "EXE"
				ML_display_vram();			//Affichage de l'cran de dfaite

				while(!key_down(31));	//Attend l'appuis de [EXE]
				break;

			}	//Fin de la boucle du jeu

		}	//Fin de la fonction du jeu

		//Selection de "Succes"
	if(ChoixMode==2){
		X=0;
		Z2=0;
		while(1){
				//Dessin de l'interface des succs
			ML_rectangle(0,0,126,62,1,1,0);			//Effaage de l'cran tout en dessinant les bordure de profondeur
			Txt_Text("<F1",2,13,TXT_MINISD,TXT_OR);		//F1
			Txt_Text("F6>",114,13,TXT_MINISD,TXT_OR);	//F6
			ML_horizontal_line(20,1,125,1);			//Ligne de sparation des medailles et du bandeau 2
			ML_vertical_line(42,20,62,3);				//1re ligne de sparation entre les medailles
			ML_vertical_line(84,20,62,3);				//2me ligne de sparation entre les medailles
			ML_bmp_or(BandeauSucces,1,1,125,10);		//Bandeau de succs
			ML_rectangle(2+X*6,1,70+X*6,10,0,0,0);		//Effaage des succs cachs par la selection
			ML_bmp_or(SelectSucce,2+X*6,1,69,10);		//Succ selectionn
			ML_bmp_or(ImTexteSucces[X],6+X*6,2,61,7);	//Nom du succ
			ML_rectangle(14,12,112,18,0,0,1);			//Rectangle noir, fond de texte d'obtention du succ slectionn
			Txt_Text(TextesSucces[Z2+X*3],16,13,TXT_MINISD,TXT_XOR);							//Texte d'obtention du succ slectionn
			for(Z=0;Z<3;Z++)ML_bmp_or(ImMedailles[(X*3+Z+1)*MedaillesObtenues[X*3+Z]],2+Z*42,22,39,39);	//Les 3 mdailles
			ML_rectangle(1+Z2*42,21,41+Z2*42,61,0,0,2);										//Mdaille slectionn

			ML_display_vram();				//Affichage de l'cran des succs

			while(key_down(27) || key_down(38) || key_down(79) || key_down(29) );	//Attend que droite/gauche /F1/F6 soient relach
			X2=X;
			Z=Z2;
			while(X==X2 && Z2==Z){
				if(key_down(27))X++;
				if(key_down(38))X--;
				if(key_down(29))Z2++;
				if(key_down(79))Z2--;
				if(key_down(48))break;	//[MENU] pour retourner au menu
				}
			if(X<0)X=9;
			if(X>9)X=0;
			if(Z2<0)Z2=2;
			if(Z2>2)Z2=0;
			if(key_down(48))break;	//[MENU] pour retourner au menu
			}
		}

		//Selection de "Stats"
	if(ChoixMode==3){
		ML_rectangle(0,0,126,62,1,1,0);			//Effaage de l'cran tout en dessinant les bordure de profondeur
		ML_bmp_or(BandeauStatistiques,1,1,125,10);	//Dessin du bandeau des statistique
		X=0;
		while(1){
			ML_rectangle(1,11,125,61,0,0,0);									//Effaage du texte des statistique
			for(Z=0;Z<7;Z++)Txt_Text(TexteStatistiques[X+Z],3,13+Z*7,TXT_MINISD,TXT_OR);	//Dessin du texte des statistiques

			for(Z=0;Z<7;Z++){
				if(Z+X<1 || Z+X>2){
					sprintf(NombreStatistiques,"%d",Statistiques[X+Z]);
					Txt_Text(NombreStatistiques,87,13+Z*7,TXT_MINISD,TXT_OR);		//Dessin des nombres correspondant au texte des statistiques
					}
				else {
					AffTxt=Statistiques[X+Z]%10;
					sprintf(NombreStatistiques,"%d",AffTxt);
					Txt_Text(NombreStatistiques,115,13+Z*7,TXT_MINISD,TXT_ON);
					AffTxt=Statistiques[X+Z]%100/10;
					sprintf(NombreStatistiques,"%d",AffTxt);
					Txt_Text(NombreStatistiques,111,13+Z*7,TXT_MINISD,TXT_ON);
					AffTxt=Statistiques[X+Z]%1000/100;
					sprintf(NombreStatistiques,"%d",AffTxt);
					Txt_Text(NombreStatistiques,103,13+Z*7,TXT_MINISD,TXT_ON);
					AffTxt=Statistiques[X+Z]%10000/1000;
					sprintf(NombreStatistiques,"%d",AffTxt);
					Txt_Text(NombreStatistiques,99,13+Z*7,TXT_MINISD,TXT_ON);
					AffTxt=Statistiques[X+Z]%100000/10000;
					sprintf(NombreStatistiques,"%d",AffTxt);
					Txt_Text(NombreStatistiques,91,13+Z*7,TXT_MINISD,TXT_ON);
					AffTxt=Statistiques[X+Z]/100000;
					sprintf(NombreStatistiques,"%d",AffTxt);
					Txt_Text(NombreStatistiques,87,13+Z*7,TXT_MINISD,TXT_ON);
					}
				}
			ML_display_vram();											//Affichage du texte

			while(key_down(37) || key_down(28));	//Attend que haut/bas soient relach

			ML_rectangle(1,1,125,10,0,0,0);			//Effaage du bandeau des statistique
			ML_bmp_or(BandeauStatistiques,1,1,125,10);	//Dessin du bandeau des statistique
			ML_display_vram();					//Affichage du bandeau des statistique
			X2=X;
			while(X==X2){
				if(key_down(37))X++;
				if(key_down(28))X--;
				if(key_down(48))break;	//[MENU] pour retourner au menu
				}
			if(X>X2)ML_rectangle(1,1,42,9,0,0,2);
			if(X<X2)ML_rectangle(76,1,125,9,0,0,2);
			if(X<0)X=10;
			if(X>10)X=0;
			if(key_down(48))break;	//[MENU] pour retourner au menu
			}
		}

		//Selection de "Credit"
	if(ChoixMode==4){
		Z=0;
		while(!key_down(31)){
			Z++;
			if(Z==1){
				ML_clear_vram();				//Effaage de l'cran
				ML_bmp_or(ImCredits,0,0,128,64);	//Dessin de l'image des crdits
				ML_display_vram();			//Affichage de l'image des crdits
				}
			if(Z==20000){
				ML_rectangle(114,55,126,61,1,1,1);	//Effaage de "EXE"
				ML_display_vram();			//Dessin de l'image des crdit sans "EXE"
				}
			if(Z==30000)Z=0;
			}
		}

	if(ChoixMode==5)break;	//Retour au menu de la calculatrice

	}	//Fin du programme
    return 1;
}

//****************************************************************************
//**************                                              ****************
//**************                 Notice!                      ****************
//**************                                              ****************
//**************  Please do not change the following source.  ****************
//**************                                              ****************
//****************************************************************************


#pragma section _BR_Size
unsigned long BR_Size;
#pragma section


#pragma section _TOP

//****************************************************************************
//  InitializeSystem
//
//  param   :   isAppli   : 1 = Application / 0 = eActivity
//              OptionNum : Option Number (only eActivity)
//
//  retval  :   1 = No error / 0 = Error
//
//****************************************************************************
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}

#pragma section

